/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ir3_yyparse
#define yylex           ir3_yylex
#define yyerror         ir3_yyerror
#define yydebug         ir3_yydebug
#define yynerrs         ir3_yynerrs
#define yylval          ir3_yylval
#define yychar          ir3_yychar

/* First part of user prologue.  */
#line 32 "../src/freedreno/ir3/ir3_parser.y"

#define YYDEBUG 0

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "util/half_float.h"
#include "util/u_math.h"

#include "ir3/ir3.h"
#include "ir3/ir3_shader.h"
#include "ir3/instr-a3xx.h"

#include "ir3_parser.h"

#define swap(a, b) \
	do { __typeof(a) __tmp = (a); (a) = (b); (b) = __tmp; } while (0)

/* ir3 treats the abs/neg flags as separate flags for float vs integer,
 * but in the instruction encoding they are the same thing.  Tracking
 * them separately is only for the benefit of ir3 opt passes, and not
 * required here, so just use the float versions:
 */
#define IR3_REG_ABS     IR3_REG_FABS
#define IR3_REG_NEGATE  IR3_REG_FNEG

static struct ir3_kernel_info    *info;
static struct ir3_shader_variant *variant;
/* NOTE the assembler doesn't really use the ir3_block construction
 * like the compiler does.  Everything is treated as one large block.
 * Which might happen to contain flow control.  But since we don't
 * use any of the ir3 backend passes (sched, RA, etc) this doesn't
 * really matter.
 */
static struct ir3_block          *block;   /* current shader block */
static struct ir3_instruction    *instr;   /* current instruction */
static unsigned ip; /* current instruction pointer */
static struct hash_table *labels;

static bool is_in_fullnop_section;
static bool is_in_fullsync_section;

void *ir3_parser_dead_ctx;

char* current_line;

static struct {
	unsigned flags;
	unsigned repeat;
	unsigned nop;
} iflags;

static struct {
	unsigned flags;
	unsigned wrmask;
} rflags;

static struct {
        uint32_t reg_address_hi;
        uint32_t reg_address_lo;
        uint32_t reg_tmp;

        uint32_t regs_to_dump[128];
        uint32_t regs_count;
} meta_print_data;

int ir3_yyget_lineno(void);

static void new_label(const char *name)
{
	ralloc_steal(labels, (void *) name);
	_mesa_hash_table_insert(labels, name, (void *)(uintptr_t)ip);
}

static struct ir3_instruction * new_instr(opc_t opc)
{
	instr = ir3_instr_create_at_end(block, opc, 4, 6);
	instr->flags = iflags.flags;
	instr->repeat = iflags.repeat;
	instr->nop = iflags.nop;
	instr->line = ir3_yyget_lineno();
	iflags.flags = iflags.repeat = iflags.nop = 0;

	if (is_in_fullnop_section) {
		struct ir3_instruction *nop =
			ir3_instr_create_at(ir3_before_instr(instr), OPC_NOP, 0, 0);
		nop->repeat = 5;
		ip++;
	}

	if (is_in_fullsync_section) {
		struct ir3_instruction *nop =
			ir3_instr_create_at(ir3_before_instr(instr), OPC_NOP, 0, 0);
		nop->flags = IR3_INSTR_SS | IR3_INSTR_SY;
		ip++;
	}

	ip++;
	return instr;
}

static void new_shader(void)
{
	variant->ir = ir3_create(variant->compiler, variant);
	block = ir3_block_create(variant->ir);
	list_addtail(&block->node, &variant->ir->block_list);
	ip = 0;
	labels = _mesa_hash_table_create(variant, _mesa_hash_string, _mesa_key_string_equal);
	ir3_parser_dead_ctx = ralloc_context(NULL);
}

static type_t parse_type(const char **type)
{
	if (!strncmp("f16", *type, 3)) {
		*type += 3;
		return TYPE_F16;
	} else if (!strncmp("f32", *type, 3)) {
		*type += 3;
		return TYPE_F32;
	} else if (!strncmp("u16", *type, 3)) {
		*type += 3;
		return TYPE_U16;
	} else if (!strncmp("u32", *type, 3)) {
		*type += 3;
		return TYPE_U32;
	} else if (!strncmp("s16", *type, 3)) {
		*type += 3;
		return TYPE_S16;
	} else if (!strncmp("s32", *type, 3)) {
		*type += 3;
		return TYPE_S32;
	} else if (!strncmp("u8", *type, 2)) {
		*type += 2;
		return TYPE_U8;
	} else if (!strncmp("u8_32", *type, 5)) {
		*type += 5;
		return TYPE_U8_32;
	} else if (!strncmp("u64", *type, 3)) {
		*type += 3;
		return TYPE_ATOMIC_U64;
	} else {
		assert(0);  /* shouldn't get here */
		return ~0;
	}
}

static struct ir3_instruction * parse_type_type(struct ir3_instruction *instr,
		const char *type_type)
{
	instr->cat1.src_type = parse_type(&type_type);
	instr->cat1.dst_type = parse_type(&type_type);
	return instr;
}

static struct ir3_register * new_src(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_src_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * new_dst(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_dst_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * dummy_dst(void)
{
	return new_dst(0, 0);
}

static void fixup_cat5_s2en(void)
{
	assert(opc_cat(instr->opc) == 5);
	if (!(instr->flags & IR3_INSTR_S2EN))
		return;
	/* For various reasons (ie. mainly to make the .s2en src easier to
	 * find, given that various different cat5 tex instructions can have
	 * different # of src registers), in ir3 the samp/tex src register
	 * is first, rather than last.  So we have to detect this case and
	 * fix things up.
	 */

	uint32_t s2en_off = instr->srcs_count - 1;
	if (instr->flags & IR3_INSTR_A1EN)
		s2en_off = instr->srcs_count - 2;

	struct ir3_register *s2en_src = instr->srcs[s2en_off];

	if (instr->flags & IR3_INSTR_B)
		assert(!(s2en_src->flags & IR3_REG_HALF));
	else
		assert(s2en_src->flags & IR3_REG_HALF);

	memmove(instr->srcs + 1, instr->srcs, s2en_off * sizeof(instr->srcs[0]));
	instr->srcs[0] = s2en_src;
}

static void add_const(unsigned reg, unsigned c0, unsigned c1, unsigned c2, unsigned c3)
{
	struct ir3_const_state *const_state = ir3_const_state_mut(variant);
	assert((reg & 0x7) == 0);
	int idx = reg >> (1 + 2); /* low bit is half vs full, next two bits are swiz */
	if (idx * 4 + 4 > const_state->immediates_size) {
		const_state->immediates = rerzalloc(const_state,
				const_state->immediates,
				__typeof__(const_state->immediates[0]),
				const_state->immediates_size,
				idx * 4 + 4);
		for (unsigned i = const_state->immediates_size; i < idx * 4; i++)
			const_state->immediates[i] = 0xd0d0d0d0;
		const_state->immediates_size = const_state->immediates_count = idx * 4 + 4;
	}
	const_state->immediates[idx * 4 + 0] = c0;
	const_state->immediates[idx * 4 + 1] = c1;
	const_state->immediates[idx * 4 + 2] = c2;
	const_state->immediates[idx * 4 + 3] = c3;
}

static void add_buf_init_val(uint32_t val)
{
	assert(info->num_bufs > 0);
	unsigned idx = info->num_bufs - 1;

	if (!info->buf_init_data[idx]) {
		unsigned sz = info->buf_sizes[idx] * 4;
		info->buf_init_data[idx] = malloc(sz);
		memset(info->buf_init_data[idx], 0, sz);
	}

	assert(info->buf_init_data_sizes[idx] < info->buf_sizes[idx]);
	info->buf_init_data[idx][info->buf_init_data_sizes[idx]++] = val;
}

static void add_sysval(unsigned reg, unsigned compmask, gl_system_value sysval)
{
	unsigned n = variant->inputs_count++;
	variant->inputs[n].regid = reg;
	variant->inputs[n].sysval = true;
	variant->inputs[n].slot = sysval;
	variant->inputs[n].compmask = compmask;
	variant->total_in++;
}

static bool resolve_labels(void)
{
	int instr_ip = 0;
	foreach_instr (instr, &block->instr_list) {
		if (opc_cat(instr->opc) == 0 && instr->cat0.target_label) {
			struct hash_entry *entry = _mesa_hash_table_search(labels, instr->cat0.target_label);
			if (!entry) {
				fprintf(stderr, "unknown label %s\n", instr->cat0.target_label);
				return false;
			}
			int target_ip = (uintptr_t)entry->data;
			instr->cat0.immed = target_ip - instr_ip;
		}
		instr_ip++;
	}
	return true;
}

#ifdef YYDEBUG
int yydebug;
#endif

extern int yylex(void);
void ir3_yyset_lineno(int _line_number);
void ir3_yyset_input(FILE *f);

int yyparse(void);

static void yyerror(const char *error)
{
	fprintf(stderr, "error at line %d: %s\n%s\n", ir3_yyget_lineno(), error, current_line);
}

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f)
{
	ir3_yyset_lineno(1);
	ir3_yyset_input(f);
#ifdef YYDEBUG
	yydebug = 1;
#endif
	info = k;
	variant = v;

	is_in_fullnop_section = false;
	is_in_fullsync_section = false;

	if (yyparse() || !resolve_labels()) {
		ir3_destroy(variant->ir);
		variant->ir = NULL;
	}
	ralloc_free(labels);
	ralloc_free(ir3_parser_dead_ctx);
	return variant->ir;
}

#line 393 "src/freedreno/ir3/ir3_parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "ir3_parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_INT = 3,                      /* T_INT  */
  YYSYMBOL_T_HEX = 4,                      /* T_HEX  */
  YYSYMBOL_T_FLOAT = 5,                    /* T_FLOAT  */
  YYSYMBOL_T_IDENTIFIER = 6,               /* T_IDENTIFIER  */
  YYSYMBOL_T_REGISTER = 7,                 /* T_REGISTER  */
  YYSYMBOL_T_CONSTANT = 8,                 /* T_CONSTANT  */
  YYSYMBOL_T_A_LOCALSIZE = 9,              /* T_A_LOCALSIZE  */
  YYSYMBOL_T_A_CONST = 10,                 /* T_A_CONST  */
  YYSYMBOL_T_A_BUF = 11,                   /* T_A_BUF  */
  YYSYMBOL_T_A_INVOCATIONID = 12,          /* T_A_INVOCATIONID  */
  YYSYMBOL_T_A_WGID = 13,                  /* T_A_WGID  */
  YYSYMBOL_T_A_NUMWG = 14,                 /* T_A_NUMWG  */
  YYSYMBOL_T_A_BRANCHSTACK = 15,           /* T_A_BRANCHSTACK  */
  YYSYMBOL_T_A_IN = 16,                    /* T_A_IN  */
  YYSYMBOL_T_A_OUT = 17,                   /* T_A_OUT  */
  YYSYMBOL_T_A_TEX = 18,                   /* T_A_TEX  */
  YYSYMBOL_T_A_PVTMEM = 19,                /* T_A_PVTMEM  */
  YYSYMBOL_T_A_LOCALMEM = 20,              /* T_A_LOCALMEM  */
  YYSYMBOL_T_A_EARLYPREAMBLE = 21,         /* T_A_EARLYPREAMBLE  */
  YYSYMBOL_T_A_FULLNOPSTART = 22,          /* T_A_FULLNOPSTART  */
  YYSYMBOL_T_A_FULLNOPEND = 23,            /* T_A_FULLNOPEND  */
  YYSYMBOL_T_A_FULLSYNCSTART = 24,         /* T_A_FULLSYNCSTART  */
  YYSYMBOL_T_A_FULLSYNCEND = 25,           /* T_A_FULLSYNCEND  */
  YYSYMBOL_T_ABSNEG = 26,                  /* T_ABSNEG  */
  YYSYMBOL_T_NEG = 27,                     /* T_NEG  */
  YYSYMBOL_T_ABS = 28,                     /* T_ABS  */
  YYSYMBOL_T_R = 29,                       /* T_R  */
  YYSYMBOL_T_LAST = 30,                    /* T_LAST  */
  YYSYMBOL_T_HR = 31,                      /* T_HR  */
  YYSYMBOL_T_HC = 32,                      /* T_HC  */
  YYSYMBOL_T_EVEN = 33,                    /* T_EVEN  */
  YYSYMBOL_T_POS_INFINITY = 34,            /* T_POS_INFINITY  */
  YYSYMBOL_T_NEG_INFINITY = 35,            /* T_NEG_INFINITY  */
  YYSYMBOL_T_EI = 36,                      /* T_EI  */
  YYSYMBOL_T_WRMASK = 37,                  /* T_WRMASK  */
  YYSYMBOL_T_FLUT_0_0 = 38,                /* T_FLUT_0_0  */
  YYSYMBOL_T_FLUT_0_5 = 39,                /* T_FLUT_0_5  */
  YYSYMBOL_T_FLUT_1_0 = 40,                /* T_FLUT_1_0  */
  YYSYMBOL_T_FLUT_2_0 = 41,                /* T_FLUT_2_0  */
  YYSYMBOL_T_FLUT_E = 42,                  /* T_FLUT_E  */
  YYSYMBOL_T_FLUT_PI = 43,                 /* T_FLUT_PI  */
  YYSYMBOL_T_FLUT_INV_PI = 44,             /* T_FLUT_INV_PI  */
  YYSYMBOL_T_FLUT_INV_LOG2_E = 45,         /* T_FLUT_INV_LOG2_E  */
  YYSYMBOL_T_FLUT_LOG2_E = 46,             /* T_FLUT_LOG2_E  */
  YYSYMBOL_T_FLUT_INV_LOG2_10 = 47,        /* T_FLUT_INV_LOG2_10  */
  YYSYMBOL_T_FLUT_LOG2_10 = 48,            /* T_FLUT_LOG2_10  */
  YYSYMBOL_T_FLUT_4_0 = 49,                /* T_FLUT_4_0  */
  YYSYMBOL_T_SY = 50,                      /* T_SY  */
  YYSYMBOL_T_SS = 51,                      /* T_SS  */
  YYSYMBOL_T_JP = 52,                      /* T_JP  */
  YYSYMBOL_T_EQ_FLAG = 53,                 /* T_EQ_FLAG  */
  YYSYMBOL_T_SAT = 54,                     /* T_SAT  */
  YYSYMBOL_T_RPT = 55,                     /* T_RPT  */
  YYSYMBOL_T_UL = 56,                      /* T_UL  */
  YYSYMBOL_T_NOP = 57,                     /* T_NOP  */
  YYSYMBOL_T_OP_NOP = 58,                  /* T_OP_NOP  */
  YYSYMBOL_T_OP_BR = 59,                   /* T_OP_BR  */
  YYSYMBOL_T_OP_BRAO = 60,                 /* T_OP_BRAO  */
  YYSYMBOL_T_OP_BRAA = 61,                 /* T_OP_BRAA  */
  YYSYMBOL_T_OP_BRAC = 62,                 /* T_OP_BRAC  */
  YYSYMBOL_T_OP_BANY = 63,                 /* T_OP_BANY  */
  YYSYMBOL_T_OP_BALL = 64,                 /* T_OP_BALL  */
  YYSYMBOL_T_OP_BRAX = 65,                 /* T_OP_BRAX  */
  YYSYMBOL_T_OP_JUMP = 66,                 /* T_OP_JUMP  */
  YYSYMBOL_T_OP_CALL = 67,                 /* T_OP_CALL  */
  YYSYMBOL_T_OP_RET = 68,                  /* T_OP_RET  */
  YYSYMBOL_T_OP_KILL = 69,                 /* T_OP_KILL  */
  YYSYMBOL_T_OP_END = 70,                  /* T_OP_END  */
  YYSYMBOL_T_OP_EMIT = 71,                 /* T_OP_EMIT  */
  YYSYMBOL_T_OP_CUT = 72,                  /* T_OP_CUT  */
  YYSYMBOL_T_OP_CHMASK = 73,               /* T_OP_CHMASK  */
  YYSYMBOL_T_OP_CHSH = 74,                 /* T_OP_CHSH  */
  YYSYMBOL_T_OP_FLOW_REV = 75,             /* T_OP_FLOW_REV  */
  YYSYMBOL_T_OP_BKT = 76,                  /* T_OP_BKT  */
  YYSYMBOL_T_OP_STKS = 77,                 /* T_OP_STKS  */
  YYSYMBOL_T_OP_STKR = 78,                 /* T_OP_STKR  */
  YYSYMBOL_T_OP_XSET = 79,                 /* T_OP_XSET  */
  YYSYMBOL_T_OP_XCLR = 80,                 /* T_OP_XCLR  */
  YYSYMBOL_T_OP_GETLAST = 81,              /* T_OP_GETLAST  */
  YYSYMBOL_T_OP_GETONE = 82,               /* T_OP_GETONE  */
  YYSYMBOL_T_OP_DBG = 83,                  /* T_OP_DBG  */
  YYSYMBOL_T_OP_SHPS = 84,                 /* T_OP_SHPS  */
  YYSYMBOL_T_OP_SHPE = 85,                 /* T_OP_SHPE  */
  YYSYMBOL_T_OP_PREDT = 86,                /* T_OP_PREDT  */
  YYSYMBOL_T_OP_PREDF = 87,                /* T_OP_PREDF  */
  YYSYMBOL_T_OP_PREDE = 88,                /* T_OP_PREDE  */
  YYSYMBOL_T_OP_MOVMSK = 89,               /* T_OP_MOVMSK  */
  YYSYMBOL_T_OP_MOVA1 = 90,                /* T_OP_MOVA1  */
  YYSYMBOL_T_OP_MOVA = 91,                 /* T_OP_MOVA  */
  YYSYMBOL_T_OP_MOV = 92,                  /* T_OP_MOV  */
  YYSYMBOL_T_OP_COV = 93,                  /* T_OP_COV  */
  YYSYMBOL_T_OP_SWZ = 94,                  /* T_OP_SWZ  */
  YYSYMBOL_T_OP_GAT = 95,                  /* T_OP_GAT  */
  YYSYMBOL_T_OP_SCT = 96,                  /* T_OP_SCT  */
  YYSYMBOL_T_OP_ADD_F = 97,                /* T_OP_ADD_F  */
  YYSYMBOL_T_OP_MIN_F = 98,                /* T_OP_MIN_F  */
  YYSYMBOL_T_OP_MAX_F = 99,                /* T_OP_MAX_F  */
  YYSYMBOL_T_OP_MUL_F = 100,               /* T_OP_MUL_F  */
  YYSYMBOL_T_OP_SIGN_F = 101,              /* T_OP_SIGN_F  */
  YYSYMBOL_T_OP_CMPS_F = 102,              /* T_OP_CMPS_F  */
  YYSYMBOL_T_OP_ABSNEG_F = 103,            /* T_OP_ABSNEG_F  */
  YYSYMBOL_T_OP_CMPV_F = 104,              /* T_OP_CMPV_F  */
  YYSYMBOL_T_OP_FLOOR_F = 105,             /* T_OP_FLOOR_F  */
  YYSYMBOL_T_OP_CEIL_F = 106,              /* T_OP_CEIL_F  */
  YYSYMBOL_T_OP_RNDNE_F = 107,             /* T_OP_RNDNE_F  */
  YYSYMBOL_T_OP_RNDAZ_F = 108,             /* T_OP_RNDAZ_F  */
  YYSYMBOL_T_OP_TRUNC_F = 109,             /* T_OP_TRUNC_F  */
  YYSYMBOL_T_OP_ADD_U = 110,               /* T_OP_ADD_U  */
  YYSYMBOL_T_OP_ADD_S = 111,               /* T_OP_ADD_S  */
  YYSYMBOL_T_OP_SUB_U = 112,               /* T_OP_SUB_U  */
  YYSYMBOL_T_OP_SUB_S = 113,               /* T_OP_SUB_S  */
  YYSYMBOL_T_OP_CMPS_U = 114,              /* T_OP_CMPS_U  */
  YYSYMBOL_T_OP_CMPS_S = 115,              /* T_OP_CMPS_S  */
  YYSYMBOL_T_OP_MIN_U = 116,               /* T_OP_MIN_U  */
  YYSYMBOL_T_OP_MIN_S = 117,               /* T_OP_MIN_S  */
  YYSYMBOL_T_OP_MAX_U = 118,               /* T_OP_MAX_U  */
  YYSYMBOL_T_OP_MAX_S = 119,               /* T_OP_MAX_S  */
  YYSYMBOL_T_OP_ABSNEG_S = 120,            /* T_OP_ABSNEG_S  */
  YYSYMBOL_T_OP_AND_B = 121,               /* T_OP_AND_B  */
  YYSYMBOL_T_OP_OR_B = 122,                /* T_OP_OR_B  */
  YYSYMBOL_T_OP_NOT_B = 123,               /* T_OP_NOT_B  */
  YYSYMBOL_T_OP_XOR_B = 124,               /* T_OP_XOR_B  */
  YYSYMBOL_T_OP_CMPV_U = 125,              /* T_OP_CMPV_U  */
  YYSYMBOL_T_OP_CMPV_S = 126,              /* T_OP_CMPV_S  */
  YYSYMBOL_T_OP_MUL_U24 = 127,             /* T_OP_MUL_U24  */
  YYSYMBOL_T_OP_MUL_S24 = 128,             /* T_OP_MUL_S24  */
  YYSYMBOL_T_OP_MULL_U = 129,              /* T_OP_MULL_U  */
  YYSYMBOL_T_OP_BFREV_B = 130,             /* T_OP_BFREV_B  */
  YYSYMBOL_T_OP_CLZ_S = 131,               /* T_OP_CLZ_S  */
  YYSYMBOL_T_OP_CLZ_B = 132,               /* T_OP_CLZ_B  */
  YYSYMBOL_T_OP_SHL_B = 133,               /* T_OP_SHL_B  */
  YYSYMBOL_T_OP_SHR_B = 134,               /* T_OP_SHR_B  */
  YYSYMBOL_T_OP_ASHR_B = 135,              /* T_OP_ASHR_B  */
  YYSYMBOL_T_OP_BARY_F = 136,              /* T_OP_BARY_F  */
  YYSYMBOL_T_OP_FLAT_B = 137,              /* T_OP_FLAT_B  */
  YYSYMBOL_T_OP_MGEN_B = 138,              /* T_OP_MGEN_B  */
  YYSYMBOL_T_OP_GETBIT_B = 139,            /* T_OP_GETBIT_B  */
  YYSYMBOL_T_OP_SETRM = 140,               /* T_OP_SETRM  */
  YYSYMBOL_T_OP_CBITS_B = 141,             /* T_OP_CBITS_B  */
  YYSYMBOL_T_OP_SHB = 142,                 /* T_OP_SHB  */
  YYSYMBOL_T_OP_MSAD = 143,                /* T_OP_MSAD  */
  YYSYMBOL_T_OP_MAD_U16 = 144,             /* T_OP_MAD_U16  */
  YYSYMBOL_T_OP_MADSH_U16 = 145,           /* T_OP_MADSH_U16  */
  YYSYMBOL_T_OP_MAD_S16 = 146,             /* T_OP_MAD_S16  */
  YYSYMBOL_T_OP_MADSH_M16 = 147,           /* T_OP_MADSH_M16  */
  YYSYMBOL_T_OP_MAD_U24 = 148,             /* T_OP_MAD_U24  */
  YYSYMBOL_T_OP_MAD_S24 = 149,             /* T_OP_MAD_S24  */
  YYSYMBOL_T_OP_MAD_F16 = 150,             /* T_OP_MAD_F16  */
  YYSYMBOL_T_OP_MAD_F32 = 151,             /* T_OP_MAD_F32  */
  YYSYMBOL_T_OP_SEL_B16 = 152,             /* T_OP_SEL_B16  */
  YYSYMBOL_T_OP_SEL_B32 = 153,             /* T_OP_SEL_B32  */
  YYSYMBOL_T_OP_SEL_S16 = 154,             /* T_OP_SEL_S16  */
  YYSYMBOL_T_OP_SEL_S32 = 155,             /* T_OP_SEL_S32  */
  YYSYMBOL_T_OP_SEL_F16 = 156,             /* T_OP_SEL_F16  */
  YYSYMBOL_T_OP_SEL_F32 = 157,             /* T_OP_SEL_F32  */
  YYSYMBOL_T_OP_SAD_S16 = 158,             /* T_OP_SAD_S16  */
  YYSYMBOL_T_OP_SAD_S32 = 159,             /* T_OP_SAD_S32  */
  YYSYMBOL_T_OP_SHRM = 160,                /* T_OP_SHRM  */
  YYSYMBOL_T_OP_SHLM = 161,                /* T_OP_SHLM  */
  YYSYMBOL_T_OP_SHRG = 162,                /* T_OP_SHRG  */
  YYSYMBOL_T_OP_SHLG = 163,                /* T_OP_SHLG  */
  YYSYMBOL_T_OP_ANDG = 164,                /* T_OP_ANDG  */
  YYSYMBOL_T_OP_DP2ACC = 165,              /* T_OP_DP2ACC  */
  YYSYMBOL_T_OP_DP4ACC = 166,              /* T_OP_DP4ACC  */
  YYSYMBOL_T_OP_WMM = 167,                 /* T_OP_WMM  */
  YYSYMBOL_T_OP_WMM_ACCU = 168,            /* T_OP_WMM_ACCU  */
  YYSYMBOL_T_OP_RCP = 169,                 /* T_OP_RCP  */
  YYSYMBOL_T_OP_RSQ = 170,                 /* T_OP_RSQ  */
  YYSYMBOL_T_OP_LOG2 = 171,                /* T_OP_LOG2  */
  YYSYMBOL_T_OP_EXP2 = 172,                /* T_OP_EXP2  */
  YYSYMBOL_T_OP_SIN = 173,                 /* T_OP_SIN  */
  YYSYMBOL_T_OP_COS = 174,                 /* T_OP_COS  */
  YYSYMBOL_T_OP_SQRT = 175,                /* T_OP_SQRT  */
  YYSYMBOL_T_OP_HRSQ = 176,                /* T_OP_HRSQ  */
  YYSYMBOL_T_OP_HLOG2 = 177,               /* T_OP_HLOG2  */
  YYSYMBOL_T_OP_HEXP2 = 178,               /* T_OP_HEXP2  */
  YYSYMBOL_T_OP_ISAM = 179,                /* T_OP_ISAM  */
  YYSYMBOL_T_OP_ISAML = 180,               /* T_OP_ISAML  */
  YYSYMBOL_T_OP_ISAMM = 181,               /* T_OP_ISAMM  */
  YYSYMBOL_T_OP_SAM = 182,                 /* T_OP_SAM  */
  YYSYMBOL_T_OP_SAMB = 183,                /* T_OP_SAMB  */
  YYSYMBOL_T_OP_SAML = 184,                /* T_OP_SAML  */
  YYSYMBOL_T_OP_SAMGQ = 185,               /* T_OP_SAMGQ  */
  YYSYMBOL_T_OP_GETLOD = 186,              /* T_OP_GETLOD  */
  YYSYMBOL_T_OP_CONV = 187,                /* T_OP_CONV  */
  YYSYMBOL_T_OP_CONVM = 188,               /* T_OP_CONVM  */
  YYSYMBOL_T_OP_GETSIZE = 189,             /* T_OP_GETSIZE  */
  YYSYMBOL_T_OP_GETBUF = 190,              /* T_OP_GETBUF  */
  YYSYMBOL_T_OP_GETPOS = 191,              /* T_OP_GETPOS  */
  YYSYMBOL_T_OP_GETINFO = 192,             /* T_OP_GETINFO  */
  YYSYMBOL_T_OP_DSX = 193,                 /* T_OP_DSX  */
  YYSYMBOL_T_OP_DSY = 194,                 /* T_OP_DSY  */
  YYSYMBOL_T_OP_GATHER4R = 195,            /* T_OP_GATHER4R  */
  YYSYMBOL_T_OP_GATHER4G = 196,            /* T_OP_GATHER4G  */
  YYSYMBOL_T_OP_GATHER4B = 197,            /* T_OP_GATHER4B  */
  YYSYMBOL_T_OP_GATHER4A = 198,            /* T_OP_GATHER4A  */
  YYSYMBOL_T_OP_SAMGP0 = 199,              /* T_OP_SAMGP0  */
  YYSYMBOL_T_OP_SAMGP1 = 200,              /* T_OP_SAMGP1  */
  YYSYMBOL_T_OP_SAMGP2 = 201,              /* T_OP_SAMGP2  */
  YYSYMBOL_T_OP_SAMGP3 = 202,              /* T_OP_SAMGP3  */
  YYSYMBOL_T_OP_DSXPP_1 = 203,             /* T_OP_DSXPP_1  */
  YYSYMBOL_T_OP_DSYPP_1 = 204,             /* T_OP_DSYPP_1  */
  YYSYMBOL_T_OP_RGETPOS = 205,             /* T_OP_RGETPOS  */
  YYSYMBOL_T_OP_RGETINFO = 206,            /* T_OP_RGETINFO  */
  YYSYMBOL_T_OP_BRCST_A = 207,             /* T_OP_BRCST_A  */
  YYSYMBOL_T_OP_QSHUFFLE_BRCST = 208,      /* T_OP_QSHUFFLE_BRCST  */
  YYSYMBOL_T_OP_QSHUFFLE_H = 209,          /* T_OP_QSHUFFLE_H  */
  YYSYMBOL_T_OP_QSHUFFLE_V = 210,          /* T_OP_QSHUFFLE_V  */
  YYSYMBOL_T_OP_QSHUFFLE_DIAG = 211,       /* T_OP_QSHUFFLE_DIAG  */
  YYSYMBOL_T_OP_TCINV = 212,               /* T_OP_TCINV  */
  YYSYMBOL_T_OP_LDG = 213,                 /* T_OP_LDG  */
  YYSYMBOL_T_OP_LDG_A = 214,               /* T_OP_LDG_A  */
  YYSYMBOL_T_OP_LDG_K = 215,               /* T_OP_LDG_K  */
  YYSYMBOL_T_OP_LDL = 216,                 /* T_OP_LDL  */
  YYSYMBOL_T_OP_LDP = 217,                 /* T_OP_LDP  */
  YYSYMBOL_T_OP_STG = 218,                 /* T_OP_STG  */
  YYSYMBOL_T_OP_STG_A = 219,               /* T_OP_STG_A  */
  YYSYMBOL_T_OP_STL = 220,                 /* T_OP_STL  */
  YYSYMBOL_T_OP_STP = 221,                 /* T_OP_STP  */
  YYSYMBOL_T_OP_LDIB = 222,                /* T_OP_LDIB  */
  YYSYMBOL_T_OP_G2L = 223,                 /* T_OP_G2L  */
  YYSYMBOL_T_OP_L2G = 224,                 /* T_OP_L2G  */
  YYSYMBOL_T_OP_PREFETCH = 225,            /* T_OP_PREFETCH  */
  YYSYMBOL_T_OP_LDLW = 226,                /* T_OP_LDLW  */
  YYSYMBOL_T_OP_STLW = 227,                /* T_OP_STLW  */
  YYSYMBOL_T_OP_RESFMT = 228,              /* T_OP_RESFMT  */
  YYSYMBOL_T_OP_RESINFO = 229,             /* T_OP_RESINFO  */
  YYSYMBOL_T_OP_ATOMIC_ADD = 230,          /* T_OP_ATOMIC_ADD  */
  YYSYMBOL_T_OP_ATOMIC_SUB = 231,          /* T_OP_ATOMIC_SUB  */
  YYSYMBOL_T_OP_ATOMIC_XCHG = 232,         /* T_OP_ATOMIC_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_INC = 233,          /* T_OP_ATOMIC_INC  */
  YYSYMBOL_T_OP_ATOMIC_DEC = 234,          /* T_OP_ATOMIC_DEC  */
  YYSYMBOL_T_OP_ATOMIC_CMPXCHG = 235,      /* T_OP_ATOMIC_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_MIN = 236,          /* T_OP_ATOMIC_MIN  */
  YYSYMBOL_T_OP_ATOMIC_MAX = 237,          /* T_OP_ATOMIC_MAX  */
  YYSYMBOL_T_OP_ATOMIC_AND = 238,          /* T_OP_ATOMIC_AND  */
  YYSYMBOL_T_OP_ATOMIC_OR = 239,           /* T_OP_ATOMIC_OR  */
  YYSYMBOL_T_OP_ATOMIC_XOR = 240,          /* T_OP_ATOMIC_XOR  */
  YYSYMBOL_T_OP_RESINFO_B = 241,           /* T_OP_RESINFO_B  */
  YYSYMBOL_T_OP_LDIB_B = 242,              /* T_OP_LDIB_B  */
  YYSYMBOL_T_OP_STIB_B = 243,              /* T_OP_STIB_B  */
  YYSYMBOL_T_OP_ATOMIC_B_ADD = 244,        /* T_OP_ATOMIC_B_ADD  */
  YYSYMBOL_T_OP_ATOMIC_B_SUB = 245,        /* T_OP_ATOMIC_B_SUB  */
  YYSYMBOL_T_OP_ATOMIC_B_XCHG = 246,       /* T_OP_ATOMIC_B_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_INC = 247,        /* T_OP_ATOMIC_B_INC  */
  YYSYMBOL_T_OP_ATOMIC_B_DEC = 248,        /* T_OP_ATOMIC_B_DEC  */
  YYSYMBOL_T_OP_ATOMIC_B_CMPXCHG = 249,    /* T_OP_ATOMIC_B_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_MIN = 250,        /* T_OP_ATOMIC_B_MIN  */
  YYSYMBOL_T_OP_ATOMIC_B_MAX = 251,        /* T_OP_ATOMIC_B_MAX  */
  YYSYMBOL_T_OP_ATOMIC_B_AND = 252,        /* T_OP_ATOMIC_B_AND  */
  YYSYMBOL_T_OP_ATOMIC_B_OR = 253,         /* T_OP_ATOMIC_B_OR  */
  YYSYMBOL_T_OP_ATOMIC_B_XOR = 254,        /* T_OP_ATOMIC_B_XOR  */
  YYSYMBOL_T_OP_ATOMIC_S_ADD = 255,        /* T_OP_ATOMIC_S_ADD  */
  YYSYMBOL_T_OP_ATOMIC_S_SUB = 256,        /* T_OP_ATOMIC_S_SUB  */
  YYSYMBOL_T_OP_ATOMIC_S_XCHG = 257,       /* T_OP_ATOMIC_S_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_INC = 258,        /* T_OP_ATOMIC_S_INC  */
  YYSYMBOL_T_OP_ATOMIC_S_DEC = 259,        /* T_OP_ATOMIC_S_DEC  */
  YYSYMBOL_T_OP_ATOMIC_S_CMPXCHG = 260,    /* T_OP_ATOMIC_S_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_MIN = 261,        /* T_OP_ATOMIC_S_MIN  */
  YYSYMBOL_T_OP_ATOMIC_S_MAX = 262,        /* T_OP_ATOMIC_S_MAX  */
  YYSYMBOL_T_OP_ATOMIC_S_AND = 263,        /* T_OP_ATOMIC_S_AND  */
  YYSYMBOL_T_OP_ATOMIC_S_OR = 264,         /* T_OP_ATOMIC_S_OR  */
  YYSYMBOL_T_OP_ATOMIC_S_XOR = 265,        /* T_OP_ATOMIC_S_XOR  */
  YYSYMBOL_T_OP_ATOMIC_G_ADD = 266,        /* T_OP_ATOMIC_G_ADD  */
  YYSYMBOL_T_OP_ATOMIC_G_SUB = 267,        /* T_OP_ATOMIC_G_SUB  */
  YYSYMBOL_T_OP_ATOMIC_G_XCHG = 268,       /* T_OP_ATOMIC_G_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_INC = 269,        /* T_OP_ATOMIC_G_INC  */
  YYSYMBOL_T_OP_ATOMIC_G_DEC = 270,        /* T_OP_ATOMIC_G_DEC  */
  YYSYMBOL_T_OP_ATOMIC_G_CMPXCHG = 271,    /* T_OP_ATOMIC_G_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_MIN = 272,        /* T_OP_ATOMIC_G_MIN  */
  YYSYMBOL_T_OP_ATOMIC_G_MAX = 273,        /* T_OP_ATOMIC_G_MAX  */
  YYSYMBOL_T_OP_ATOMIC_G_AND = 274,        /* T_OP_ATOMIC_G_AND  */
  YYSYMBOL_T_OP_ATOMIC_G_OR = 275,         /* T_OP_ATOMIC_G_OR  */
  YYSYMBOL_T_OP_ATOMIC_G_XOR = 276,        /* T_OP_ATOMIC_G_XOR  */
  YYSYMBOL_T_OP_LDGB = 277,                /* T_OP_LDGB  */
  YYSYMBOL_T_OP_STGB = 278,                /* T_OP_STGB  */
  YYSYMBOL_T_OP_STIB = 279,                /* T_OP_STIB  */
  YYSYMBOL_T_OP_LDC = 280,                 /* T_OP_LDC  */
  YYSYMBOL_T_OP_LDLV = 281,                /* T_OP_LDLV  */
  YYSYMBOL_T_OP_GETSPID = 282,             /* T_OP_GETSPID  */
  YYSYMBOL_T_OP_GETWID = 283,              /* T_OP_GETWID  */
  YYSYMBOL_T_OP_GETFIBERID = 284,          /* T_OP_GETFIBERID  */
  YYSYMBOL_T_OP_STC = 285,                 /* T_OP_STC  */
  YYSYMBOL_T_OP_STSC = 286,                /* T_OP_STSC  */
  YYSYMBOL_T_OP_SHFL = 287,                /* T_OP_SHFL  */
  YYSYMBOL_T_OP_BAR = 288,                 /* T_OP_BAR  */
  YYSYMBOL_T_OP_FENCE = 289,               /* T_OP_FENCE  */
  YYSYMBOL_T_OP_SLEEP = 290,               /* T_OP_SLEEP  */
  YYSYMBOL_T_OP_ICINV = 291,               /* T_OP_ICINV  */
  YYSYMBOL_T_OP_DCCLN = 292,               /* T_OP_DCCLN  */
  YYSYMBOL_T_OP_DCINV = 293,               /* T_OP_DCINV  */
  YYSYMBOL_T_OP_DCFLU = 294,               /* T_OP_DCFLU  */
  YYSYMBOL_T_OP_CCINV = 295,               /* T_OP_CCINV  */
  YYSYMBOL_T_OP_LOCK = 296,                /* T_OP_LOCK  */
  YYSYMBOL_T_OP_UNLOCK = 297,              /* T_OP_UNLOCK  */
  YYSYMBOL_T_OP_ALIAS = 298,               /* T_OP_ALIAS  */
  YYSYMBOL_T_RAW = 299,                    /* T_RAW  */
  YYSYMBOL_T_OP_PRINT = 300,               /* T_OP_PRINT  */
  YYSYMBOL_T_TYPE_F16 = 301,               /* T_TYPE_F16  */
  YYSYMBOL_T_TYPE_F32 = 302,               /* T_TYPE_F32  */
  YYSYMBOL_T_TYPE_U16 = 303,               /* T_TYPE_U16  */
  YYSYMBOL_T_TYPE_U32 = 304,               /* T_TYPE_U32  */
  YYSYMBOL_T_TYPE_S16 = 305,               /* T_TYPE_S16  */
  YYSYMBOL_T_TYPE_S32 = 306,               /* T_TYPE_S32  */
  YYSYMBOL_T_TYPE_U8 = 307,                /* T_TYPE_U8  */
  YYSYMBOL_T_TYPE_U8_32 = 308,             /* T_TYPE_U8_32  */
  YYSYMBOL_T_TYPE_U64 = 309,               /* T_TYPE_U64  */
  YYSYMBOL_T_UNTYPED = 310,                /* T_UNTYPED  */
  YYSYMBOL_T_TYPED = 311,                  /* T_TYPED  */
  YYSYMBOL_T_MIXED = 312,                  /* T_MIXED  */
  YYSYMBOL_T_UNSIGNED = 313,               /* T_UNSIGNED  */
  YYSYMBOL_T_LOW = 314,                    /* T_LOW  */
  YYSYMBOL_T_HIGH = 315,                   /* T_HIGH  */
  YYSYMBOL_T_1D = 316,                     /* T_1D  */
  YYSYMBOL_T_2D = 317,                     /* T_2D  */
  YYSYMBOL_T_3D = 318,                     /* T_3D  */
  YYSYMBOL_T_4D = 319,                     /* T_4D  */
  YYSYMBOL_T_LT = 320,                     /* T_LT  */
  YYSYMBOL_T_LE = 321,                     /* T_LE  */
  YYSYMBOL_T_GT = 322,                     /* T_GT  */
  YYSYMBOL_T_GE = 323,                     /* T_GE  */
  YYSYMBOL_T_EQ = 324,                     /* T_EQ  */
  YYSYMBOL_T_NE = 325,                     /* T_NE  */
  YYSYMBOL_T_S2EN = 326,                   /* T_S2EN  */
  YYSYMBOL_T_SAMP = 327,                   /* T_SAMP  */
  YYSYMBOL_T_TEX = 328,                    /* T_TEX  */
  YYSYMBOL_T_BASE = 329,                   /* T_BASE  */
  YYSYMBOL_T_OFFSET = 330,                 /* T_OFFSET  */
  YYSYMBOL_T_UNIFORM = 331,                /* T_UNIFORM  */
  YYSYMBOL_T_NONUNIFORM = 332,             /* T_NONUNIFORM  */
  YYSYMBOL_T_IMM = 333,                    /* T_IMM  */
  YYSYMBOL_T_NAN = 334,                    /* T_NAN  */
  YYSYMBOL_T_INF = 335,                    /* T_INF  */
  YYSYMBOL_T_A0 = 336,                     /* T_A0  */
  YYSYMBOL_T_A1 = 337,                     /* T_A1  */
  YYSYMBOL_T_P0 = 338,                     /* T_P0  */
  YYSYMBOL_T_W = 339,                      /* T_W  */
  YYSYMBOL_T_CAT1_TYPE_TYPE = 340,         /* T_CAT1_TYPE_TYPE  */
  YYSYMBOL_T_INSTR_TYPE = 341,             /* T_INSTR_TYPE  */
  YYSYMBOL_T_MOD_TEX = 342,                /* T_MOD_TEX  */
  YYSYMBOL_T_MOD_MEM = 343,                /* T_MOD_MEM  */
  YYSYMBOL_T_MOD_RT = 344,                 /* T_MOD_RT  */
  YYSYMBOL_T_MOD_XOR = 345,                /* T_MOD_XOR  */
  YYSYMBOL_T_MOD_UP = 346,                 /* T_MOD_UP  */
  YYSYMBOL_T_MOD_DOWN = 347,               /* T_MOD_DOWN  */
  YYSYMBOL_T_MOD_RUP = 348,                /* T_MOD_RUP  */
  YYSYMBOL_T_MOD_RDOWN = 349,              /* T_MOD_RDOWN  */
  YYSYMBOL_350_ = 350,                     /* '-'  */
  YYSYMBOL_351_ = 351,                     /* ','  */
  YYSYMBOL_352_ = 352,                     /* '('  */
  YYSYMBOL_353_ = 353,                     /* ')'  */
  YYSYMBOL_354_ = 354,                     /* '='  */
  YYSYMBOL_355_ = 355,                     /* ':'  */
  YYSYMBOL_356_ = 356,                     /* '!'  */
  YYSYMBOL_357_ = 357,                     /* '#'  */
  YYSYMBOL_358_ = 358,                     /* '.'  */
  YYSYMBOL_359_a_ = 359,                   /* 'a'  */
  YYSYMBOL_360_o_ = 360,                   /* 'o'  */
  YYSYMBOL_361_p_ = 361,                   /* 'p'  */
  YYSYMBOL_362_s_ = 362,                   /* 's'  */
  YYSYMBOL_363_v_ = 363,                   /* 'v'  */
  YYSYMBOL_364_ = 364,                     /* '+'  */
  YYSYMBOL_365_ = 365,                     /* '<'  */
  YYSYMBOL_366_g_ = 366,                   /* 'g'  */
  YYSYMBOL_367_ = 367,                     /* '['  */
  YYSYMBOL_368_ = 368,                     /* ']'  */
  YYSYMBOL_369_c_ = 369,                   /* 'c'  */
  YYSYMBOL_370_l_ = 370,                   /* 'l'  */
  YYSYMBOL_371_u_ = 371,                   /* 'u'  */
  YYSYMBOL_372_k_ = 372,                   /* 'k'  */
  YYSYMBOL_373_w_ = 373,                   /* 'w'  */
  YYSYMBOL_374_r_ = 374,                   /* 'r'  */
  YYSYMBOL_375_ = 375,                     /* '>'  */
  YYSYMBOL_376_h_ = 376,                   /* 'h'  */
  YYSYMBOL_YYACCEPT = 377,                 /* $accept  */
  YYSYMBOL_shader = 378,                   /* shader  */
  YYSYMBOL_379_1 = 379,                    /* $@1  */
  YYSYMBOL_headers = 380,                  /* headers  */
  YYSYMBOL_header = 381,                   /* header  */
  YYSYMBOL_const_val = 382,                /* const_val  */
  YYSYMBOL_localsize_header = 383,         /* localsize_header  */
  YYSYMBOL_const_header = 384,             /* const_header  */
  YYSYMBOL_buf_header_init_val = 385,      /* buf_header_init_val  */
  YYSYMBOL_buf_header_init_vals = 386,     /* buf_header_init_vals  */
  YYSYMBOL_buf_header_addr_reg = 387,      /* buf_header_addr_reg  */
  YYSYMBOL_buf_header = 388,               /* buf_header  */
  YYSYMBOL_389_2 = 389,                    /* $@2  */
  YYSYMBOL_invocationid_header = 390,      /* invocationid_header  */
  YYSYMBOL_wgid_header = 391,              /* wgid_header  */
  YYSYMBOL_numwg_header = 392,             /* numwg_header  */
  YYSYMBOL_branchstack_header = 393,       /* branchstack_header  */
  YYSYMBOL_pvtmem_header = 394,            /* pvtmem_header  */
  YYSYMBOL_localmem_header = 395,          /* localmem_header  */
  YYSYMBOL_earlypreamble_header = 396,     /* earlypreamble_header  */
  YYSYMBOL_in_header = 397,                /* in_header  */
  YYSYMBOL_out_header = 398,               /* out_header  */
  YYSYMBOL_tex_header = 399,               /* tex_header  */
  YYSYMBOL_fullnop_start_section = 400,    /* fullnop_start_section  */
  YYSYMBOL_fullnop_end_section = 401,      /* fullnop_end_section  */
  YYSYMBOL_fullsync_start_section = 402,   /* fullsync_start_section  */
  YYSYMBOL_fullsync_end_section = 403,     /* fullsync_end_section  */
  YYSYMBOL_iflag = 404,                    /* iflag  */
  YYSYMBOL_iflags = 405,                   /* iflags  */
  YYSYMBOL_instrs = 406,                   /* instrs  */
  YYSYMBOL_instr = 407,                    /* instr  */
  YYSYMBOL_label = 408,                    /* label  */
  YYSYMBOL_cat0_src1 = 409,                /* cat0_src1  */
  YYSYMBOL_cat0_src2 = 410,                /* cat0_src2  */
  YYSYMBOL_cat0_immed = 411,               /* cat0_immed  */
  YYSYMBOL_cat0_instr = 412,               /* cat0_instr  */
  YYSYMBOL_413_3 = 413,                    /* $@3  */
  YYSYMBOL_414_4 = 414,                    /* $@4  */
  YYSYMBOL_415_5 = 415,                    /* $@5  */
  YYSYMBOL_416_6 = 416,                    /* $@6  */
  YYSYMBOL_417_7 = 417,                    /* $@7  */
  YYSYMBOL_418_8 = 418,                    /* $@8  */
  YYSYMBOL_419_9 = 419,                    /* $@9  */
  YYSYMBOL_420_10 = 420,                   /* $@10  */
  YYSYMBOL_421_11 = 421,                   /* $@11  */
  YYSYMBOL_422_12 = 422,                   /* $@12  */
  YYSYMBOL_423_13 = 423,                   /* $@13  */
  YYSYMBOL_424_14 = 424,                   /* $@14  */
  YYSYMBOL_425_15 = 425,                   /* $@15  */
  YYSYMBOL_426_16 = 426,                   /* $@16  */
  YYSYMBOL_cat1_opc = 427,                 /* cat1_opc  */
  YYSYMBOL_cat1_src = 428,                 /* cat1_src  */
  YYSYMBOL_cat1_movmsk = 429,              /* cat1_movmsk  */
  YYSYMBOL_430_17 = 430,                   /* $@17  */
  YYSYMBOL_mova_src = 431,                 /* mova_src  */
  YYSYMBOL_cat1_mova1 = 432,               /* cat1_mova1  */
  YYSYMBOL_433_18 = 433,                   /* $@18  */
  YYSYMBOL_cat1_mova = 434,                /* cat1_mova  */
  YYSYMBOL_435_19 = 435,                   /* $@19  */
  YYSYMBOL_cat1_swz = 436,                 /* cat1_swz  */
  YYSYMBOL_437_20 = 437,                   /* $@20  */
  YYSYMBOL_cat1_gat = 438,                 /* cat1_gat  */
  YYSYMBOL_439_21 = 439,                   /* $@21  */
  YYSYMBOL_cat1_sct = 440,                 /* cat1_sct  */
  YYSYMBOL_441_22 = 441,                   /* $@22  */
  YYSYMBOL_cat1_instr = 442,               /* cat1_instr  */
  YYSYMBOL_cat2_opc_1src = 443,            /* cat2_opc_1src  */
  YYSYMBOL_cat2_opc_2src_cnd = 444,        /* cat2_opc_2src_cnd  */
  YYSYMBOL_cat2_opc_2src = 445,            /* cat2_opc_2src  */
  YYSYMBOL_cond = 446,                     /* cond  */
  YYSYMBOL_cat2_instr = 447,               /* cat2_instr  */
  YYSYMBOL_cat3_dp_signedness = 448,       /* cat3_dp_signedness  */
  YYSYMBOL_cat3_dp_pack = 449,             /* cat3_dp_pack  */
  YYSYMBOL_cat3_opc = 450,                 /* cat3_opc  */
  YYSYMBOL_cat3_imm_reg_opc = 451,         /* cat3_imm_reg_opc  */
  YYSYMBOL_cat3_wmm = 452,                 /* cat3_wmm  */
  YYSYMBOL_cat3_dp = 453,                  /* cat3_dp  */
  YYSYMBOL_cat3_instr = 454,               /* cat3_instr  */
  YYSYMBOL_cat4_opc = 455,                 /* cat4_opc  */
  YYSYMBOL_cat4_instr = 456,               /* cat4_instr  */
  YYSYMBOL_cat5_opc_dsxypp = 457,          /* cat5_opc_dsxypp  */
  YYSYMBOL_cat5_opc_isam = 458,            /* cat5_opc_isam  */
  YYSYMBOL_cat5_opc = 459,                 /* cat5_opc  */
  YYSYMBOL_cat5_flag = 460,                /* cat5_flag  */
  YYSYMBOL_cat5_flags = 461,               /* cat5_flags  */
  YYSYMBOL_cat5_samp = 462,                /* cat5_samp  */
  YYSYMBOL_cat5_tex = 463,                 /* cat5_tex  */
  YYSYMBOL_cat5_type = 464,                /* cat5_type  */
  YYSYMBOL_cat5_a1 = 465,                  /* cat5_a1  */
  YYSYMBOL_cat5_samp_tex = 466,            /* cat5_samp_tex  */
  YYSYMBOL_cat5_samp_tex_all = 467,        /* cat5_samp_tex_all  */
  YYSYMBOL_cat5_instr = 468,               /* cat5_instr  */
  YYSYMBOL_cat6_typed = 469,               /* cat6_typed  */
  YYSYMBOL_cat6_dim = 470,                 /* cat6_dim  */
  YYSYMBOL_cat6_type = 471,                /* cat6_type  */
  YYSYMBOL_cat6_imm_offset = 472,          /* cat6_imm_offset  */
  YYSYMBOL_cat6_offset = 473,              /* cat6_offset  */
  YYSYMBOL_cat6_dst_offset = 474,          /* cat6_dst_offset  */
  YYSYMBOL_cat6_immed = 475,               /* cat6_immed  */
  YYSYMBOL_cat6_a6xx_global_address_pt3 = 476, /* cat6_a6xx_global_address_pt3  */
  YYSYMBOL_cat6_a6xx_global_address_pt2 = 477, /* cat6_a6xx_global_address_pt2  */
  YYSYMBOL_cat6_a6xx_global_address = 478, /* cat6_a6xx_global_address  */
  YYSYMBOL_cat6_load = 479,                /* cat6_load  */
  YYSYMBOL_480_23 = 480,                   /* $@23  */
  YYSYMBOL_481_24 = 481,                   /* $@24  */
  YYSYMBOL_482_25 = 482,                   /* $@25  */
  YYSYMBOL_483_26 = 483,                   /* $@26  */
  YYSYMBOL_484_27 = 484,                   /* $@27  */
  YYSYMBOL_485_28 = 485,                   /* $@28  */
  YYSYMBOL_486_29 = 486,                   /* $@29  */
  YYSYMBOL_487_30 = 487,                   /* $@30  */
  YYSYMBOL_cat6_store = 488,               /* cat6_store  */
  YYSYMBOL_489_31 = 489,                   /* $@31  */
  YYSYMBOL_490_32 = 490,                   /* $@32  */
  YYSYMBOL_491_33 = 491,                   /* $@33  */
  YYSYMBOL_492_34 = 492,                   /* $@34  */
  YYSYMBOL_493_35 = 493,                   /* $@35  */
  YYSYMBOL_cat6_loadib = 494,              /* cat6_loadib  */
  YYSYMBOL_495_36 = 495,                   /* $@36  */
  YYSYMBOL_cat6_storeib = 496,             /* cat6_storeib  */
  YYSYMBOL_497_37 = 497,                   /* $@37  */
  YYSYMBOL_cat6_prefetch = 498,            /* cat6_prefetch  */
  YYSYMBOL_499_38 = 499,                   /* $@38  */
  YYSYMBOL_cat6_atomic_opc = 500,          /* cat6_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_opc = 501,     /* cat6_a3xx_atomic_opc  */
  YYSYMBOL_cat6_a6xx_atomic_opc = 502,     /* cat6_a6xx_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_s = 503,       /* cat6_a3xx_atomic_s  */
  YYSYMBOL_cat6_a6xx_atomic_g = 504,       /* cat6_a6xx_atomic_g  */
  YYSYMBOL_cat6_atomic_l = 505,            /* cat6_atomic_l  */
  YYSYMBOL_cat6_atomic = 506,              /* cat6_atomic  */
  YYSYMBOL_cat6_ibo_opc_1src = 507,        /* cat6_ibo_opc_1src  */
  YYSYMBOL_cat6_ibo_opc_ldgb = 508,        /* cat6_ibo_opc_ldgb  */
  YYSYMBOL_cat6_ibo_opc_stgb = 509,        /* cat6_ibo_opc_stgb  */
  YYSYMBOL_cat6_ibo = 510,                 /* cat6_ibo  */
  YYSYMBOL_511_39 = 511,                   /* $@39  */
  YYSYMBOL_cat6_id_opc = 512,              /* cat6_id_opc  */
  YYSYMBOL_cat6_id = 513,                  /* cat6_id  */
  YYSYMBOL_cat6_bindless_base = 514,       /* cat6_bindless_base  */
  YYSYMBOL_cat6_bindless_mode = 515,       /* cat6_bindless_mode  */
  YYSYMBOL_cat6_reg_or_immed = 516,        /* cat6_reg_or_immed  */
  YYSYMBOL_cat6_bindless_ibo_opc_1src = 517, /* cat6_bindless_ibo_opc_1src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src = 518, /* cat6_bindless_ibo_opc_2src  */
  YYSYMBOL_cat6_bindless_ibo_opc_3src = 519, /* cat6_bindless_ibo_opc_3src  */
  YYSYMBOL_cat6_bindless_ibo_opc_3src_dst = 520, /* cat6_bindless_ibo_opc_3src_dst  */
  YYSYMBOL_cat6_bindless_ibo = 521,        /* cat6_bindless_ibo  */
  YYSYMBOL_cat6_bindless_ldc_opc = 522,    /* cat6_bindless_ldc_opc  */
  YYSYMBOL_cat6_bindless_ldc_middle = 523, /* cat6_bindless_ldc_middle  */
  YYSYMBOL_cat6_bindless_ldc = 524,        /* cat6_bindless_ldc  */
  YYSYMBOL_const_dst = 525,                /* const_dst  */
  YYSYMBOL_cat6_stc = 526,                 /* cat6_stc  */
  YYSYMBOL_527_40 = 527,                   /* $@40  */
  YYSYMBOL_528_41 = 528,                   /* $@41  */
  YYSYMBOL_cat6_shfl_mode = 529,           /* cat6_shfl_mode  */
  YYSYMBOL_cat6_shfl = 530,                /* cat6_shfl  */
  YYSYMBOL_531_42 = 531,                   /* $@42  */
  YYSYMBOL_cat6_todo = 532,                /* cat6_todo  */
  YYSYMBOL_cat6_instr = 533,               /* cat6_instr  */
  YYSYMBOL_cat7_scope = 534,               /* cat7_scope  */
  YYSYMBOL_cat7_scopes = 535,              /* cat7_scopes  */
  YYSYMBOL_cat7_barrier = 536,             /* cat7_barrier  */
  YYSYMBOL_537_43 = 537,                   /* $@43  */
  YYSYMBOL_538_44 = 538,                   /* $@44  */
  YYSYMBOL_cat7_data_cache = 539,          /* cat7_data_cache  */
  YYSYMBOL_cat7_alias_src = 540,           /* cat7_alias_src  */
  YYSYMBOL_cat7_alias_scope = 541,         /* cat7_alias_scope  */
  YYSYMBOL_cat7_instr = 542,               /* cat7_instr  */
  YYSYMBOL_543_45 = 543,                   /* $@45  */
  YYSYMBOL_raw_instr = 544,                /* raw_instr  */
  YYSYMBOL_meta_print_regs = 545,          /* meta_print_regs  */
  YYSYMBOL_meta_print_reg = 546,           /* meta_print_reg  */
  YYSYMBOL_meta_print_start = 547,         /* meta_print_start  */
  YYSYMBOL_meta_print = 548,               /* meta_print  */
  YYSYMBOL_src_gpr = 549,                  /* src_gpr  */
  YYSYMBOL_src_a0 = 550,                   /* src_a0  */
  YYSYMBOL_src_a1 = 551,                   /* src_a1  */
  YYSYMBOL_src_p0 = 552,                   /* src_p0  */
  YYSYMBOL_src = 553,                      /* src  */
  YYSYMBOL_dst = 554,                      /* dst  */
  YYSYMBOL_const = 555,                    /* const  */
  YYSYMBOL_dst_reg_flag = 556,             /* dst_reg_flag  */
  YYSYMBOL_dst_reg_flags = 557,            /* dst_reg_flags  */
  YYSYMBOL_dst_reg = 558,                  /* dst_reg  */
  YYSYMBOL_src_reg_flag = 559,             /* src_reg_flag  */
  YYSYMBOL_src_reg_flags = 560,            /* src_reg_flags  */
  YYSYMBOL_src_reg = 561,                  /* src_reg  */
  YYSYMBOL_src_reg_gpr = 562,              /* src_reg_gpr  */
  YYSYMBOL_src_const = 563,                /* src_const  */
  YYSYMBOL_src_reg_or_const = 564,         /* src_reg_or_const  */
  YYSYMBOL_src_reg_or_const_or_rel = 565,  /* src_reg_or_const_or_rel  */
  YYSYMBOL_src_reg_or_const_or_rel_or_imm = 566, /* src_reg_or_const_or_rel_or_imm  */
  YYSYMBOL_src_reg_or_rel_or_imm = 567,    /* src_reg_or_rel_or_imm  */
  YYSYMBOL_uoffset = 568,                  /* uoffset  */
  YYSYMBOL_offset = 569,                   /* offset  */
  YYSYMBOL_src_uoffset = 570,              /* src_uoffset  */
  YYSYMBOL_relative_gpr_src = 571,         /* relative_gpr_src  */
  YYSYMBOL_relative_gpr_dst = 572,         /* relative_gpr_dst  */
  YYSYMBOL_relative_const = 573,           /* relative_const  */
  YYSYMBOL_relative = 574,                 /* relative  */
  YYSYMBOL_immediate_cat1 = 575,           /* immediate_cat1  */
  YYSYMBOL_immediate = 576,                /* immediate  */
  YYSYMBOL_flut_immed = 577,               /* flut_immed  */
  YYSYMBOL_integer = 578,                  /* integer  */
  YYSYMBOL_float = 579,                    /* float  */
  YYSYMBOL_type = 580                      /* type  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 362 "../src/freedreno/ir3/ir3_parser.y"

#if YYDEBUG
static void print_token(FILE *file, int type, YYSTYPE value)
{
	fprintf(file, "\ntype: %d\n", type);
}

#define YYPRINT(file, type, value) print_token(file, type, value)
#endif

#line 1018 "src/freedreno/ir3/ir3_parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1790

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  377
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  204
/* YYNRULES -- Number of rules.  */
#define YYNRULES  616
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1297

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   604


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   356,     2,   357,     2,     2,     2,     2,
     352,   353,     2,   364,   351,   350,   358,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   355,     2,
     365,   354,   375,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   367,     2,   368,     2,     2,     2,   359,     2,   369,
       2,     2,     2,   366,   376,     2,     2,   372,   370,     2,
       2,   360,   361,     2,   374,   362,     2,   371,   363,   373,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   780,   780,   780,   782,   783,   785,   786,   787,   788,
     789,   790,   791,   792,   793,   794,   795,   796,   797,   799,
     800,   801,   802,   804,   810,   814,   815,   816,   817,   820,
     828,   830,   830,   836,   842,   849,   856,   865,   867,   869,
     871,   874,   876,   878,   885,   886,   887,   888,   890,   891,
     892,   893,   894,   895,   896,   897,   899,   900,   902,   903,
     905,   906,   907,   908,   909,   910,   911,   912,   913,   914,
     915,   916,   917,   918,   919,   921,   923,   924,   926,   927,
     929,   930,   932,   933,   933,   934,   934,   935,   935,   936,
     936,   937,   937,   938,   938,   939,   939,   940,   940,   941,
     941,   942,   943,   943,   944,   945,   946,   947,   948,   949,
     950,   950,   951,   952,   953,   954,   955,   955,   956,   957,
     957,   958,   959,   960,   961,   962,   962,   964,   967,   971,
     972,   974,   974,   990,   991,   992,   994,   994,  1001,  1001,
    1008,  1008,  1010,  1010,  1012,  1012,  1015,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1024,  1025,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,  1039,  1040,
    1041,  1042,  1043,  1044,  1046,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,
    1072,  1074,  1075,  1076,  1077,  1078,  1079,  1081,  1082,  1083,
    1085,  1086,  1088,  1089,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1104,  1105,  1106,
    1108,  1109,  1110,  1111,  1112,  1114,  1115,  1117,  1118,  1120,
    1121,  1122,  1123,  1125,  1126,  1127,  1128,  1129,  1130,  1131,
    1132,  1133,  1134,  1136,  1138,  1139,  1141,  1143,  1144,  1145,
    1146,  1147,  1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,
    1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,
    1166,  1167,  1168,  1169,  1170,  1171,  1172,  1174,  1175,  1176,
    1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,  1185,  1186,
    1188,  1189,  1190,  1191,  1193,  1194,  1195,  1196,  1198,  1199,
    1200,  1201,  1203,  1204,  1205,  1206,  1207,  1208,  1209,  1210,
    1211,  1213,  1214,  1216,  1217,  1218,  1219,  1221,  1222,  1223,
    1224,  1225,  1226,  1228,  1231,  1236,  1242,  1248,  1251,  1253,
    1253,  1254,  1254,  1255,  1255,  1256,  1256,  1257,  1257,  1258,
    1258,  1259,  1259,  1259,  1263,  1263,  1264,  1264,  1265,  1265,
    1266,  1266,  1267,  1267,  1269,  1269,  1270,  1270,  1272,  1272,
    1274,  1275,  1276,  1277,  1278,  1279,  1280,  1281,  1282,  1283,
    1284,  1286,  1287,  1288,  1289,  1290,  1291,  1292,  1293,  1294,
    1295,  1296,  1298,  1299,  1300,  1301,  1302,  1303,  1304,  1305,
    1306,  1307,  1308,  1310,  1312,  1314,  1316,  1317,  1318,  1320,
    1322,  1323,  1325,  1326,  1327,  1327,  1330,  1331,  1332,  1334,
    1336,  1337,  1339,  1340,  1341,  1343,  1344,  1346,  1348,  1349,
    1350,  1351,  1352,  1353,  1354,  1355,  1356,  1357,  1358,  1360,
    1362,  1364,  1365,  1366,  1367,  1369,  1373,  1374,  1375,  1377,
    1383,  1384,  1385,  1388,  1388,  1389,  1389,  1391,  1392,  1393,
    1394,  1395,  1399,  1402,  1402,  1405,  1406,  1407,  1409,  1410,
    1411,  1412,  1413,  1414,  1415,  1416,  1417,  1418,  1419,  1420,
    1421,  1423,  1424,  1425,  1426,  1428,  1429,  1431,  1431,  1432,
    1432,  1434,  1435,  1436,  1438,  1439,  1441,  1442,  1443,  1445,
    1446,  1447,  1448,  1449,  1450,  1451,  1452,  1452,  1459,  1461,
    1462,  1464,  1468,  1475,  1533,  1534,  1535,  1536,  1538,  1539,
    1540,  1541,  1543,  1544,  1545,  1546,  1548,  1550,  1551,  1552,
    1553,  1554,  1556,  1557,  1560,  1561,  1563,  1564,  1565,  1566,
    1567,  1569,  1570,  1572,  1573,  1575,  1576,  1578,  1579,  1581,
    1582,  1584,  1585,  1586,  1588,  1589,  1590,  1592,  1593,  1594,
    1596,  1597,  1599,  1600,  1602,  1604,  1605,  1607,  1608,  1610,
    1611,  1613,  1614,  1623,  1624,  1625,  1626,  1627,  1628,  1629,
    1630,  1631,  1632,  1633,  1634,  1636,  1637,  1638,  1639,  1640,
    1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1651,  1652,
    1653,  1654,  1656,  1657,  1658,  1659,  1661,  1662,  1664,  1665,
    1666,  1667,  1668,  1669,  1670,  1671,  1672
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_INT", "T_HEX",
  "T_FLOAT", "T_IDENTIFIER", "T_REGISTER", "T_CONSTANT", "T_A_LOCALSIZE",
  "T_A_CONST", "T_A_BUF", "T_A_INVOCATIONID", "T_A_WGID", "T_A_NUMWG",
  "T_A_BRANCHSTACK", "T_A_IN", "T_A_OUT", "T_A_TEX", "T_A_PVTMEM",
  "T_A_LOCALMEM", "T_A_EARLYPREAMBLE", "T_A_FULLNOPSTART",
  "T_A_FULLNOPEND", "T_A_FULLSYNCSTART", "T_A_FULLSYNCEND", "T_ABSNEG",
  "T_NEG", "T_ABS", "T_R", "T_LAST", "T_HR", "T_HC", "T_EVEN",
  "T_POS_INFINITY", "T_NEG_INFINITY", "T_EI", "T_WRMASK", "T_FLUT_0_0",
  "T_FLUT_0_5", "T_FLUT_1_0", "T_FLUT_2_0", "T_FLUT_E", "T_FLUT_PI",
  "T_FLUT_INV_PI", "T_FLUT_INV_LOG2_E", "T_FLUT_LOG2_E",
  "T_FLUT_INV_LOG2_10", "T_FLUT_LOG2_10", "T_FLUT_4_0", "T_SY", "T_SS",
  "T_JP", "T_EQ_FLAG", "T_SAT", "T_RPT", "T_UL", "T_NOP", "T_OP_NOP",
  "T_OP_BR", "T_OP_BRAO", "T_OP_BRAA", "T_OP_BRAC", "T_OP_BANY",
  "T_OP_BALL", "T_OP_BRAX", "T_OP_JUMP", "T_OP_CALL", "T_OP_RET",
  "T_OP_KILL", "T_OP_END", "T_OP_EMIT", "T_OP_CUT", "T_OP_CHMASK",
  "T_OP_CHSH", "T_OP_FLOW_REV", "T_OP_BKT", "T_OP_STKS", "T_OP_STKR",
  "T_OP_XSET", "T_OP_XCLR", "T_OP_GETLAST", "T_OP_GETONE", "T_OP_DBG",
  "T_OP_SHPS", "T_OP_SHPE", "T_OP_PREDT", "T_OP_PREDF", "T_OP_PREDE",
  "T_OP_MOVMSK", "T_OP_MOVA1", "T_OP_MOVA", "T_OP_MOV", "T_OP_COV",
  "T_OP_SWZ", "T_OP_GAT", "T_OP_SCT", "T_OP_ADD_F", "T_OP_MIN_F",
  "T_OP_MAX_F", "T_OP_MUL_F", "T_OP_SIGN_F", "T_OP_CMPS_F",
  "T_OP_ABSNEG_F", "T_OP_CMPV_F", "T_OP_FLOOR_F", "T_OP_CEIL_F",
  "T_OP_RNDNE_F", "T_OP_RNDAZ_F", "T_OP_TRUNC_F", "T_OP_ADD_U",
  "T_OP_ADD_S", "T_OP_SUB_U", "T_OP_SUB_S", "T_OP_CMPS_U", "T_OP_CMPS_S",
  "T_OP_MIN_U", "T_OP_MIN_S", "T_OP_MAX_U", "T_OP_MAX_S", "T_OP_ABSNEG_S",
  "T_OP_AND_B", "T_OP_OR_B", "T_OP_NOT_B", "T_OP_XOR_B", "T_OP_CMPV_U",
  "T_OP_CMPV_S", "T_OP_MUL_U24", "T_OP_MUL_S24", "T_OP_MULL_U",
  "T_OP_BFREV_B", "T_OP_CLZ_S", "T_OP_CLZ_B", "T_OP_SHL_B", "T_OP_SHR_B",
  "T_OP_ASHR_B", "T_OP_BARY_F", "T_OP_FLAT_B", "T_OP_MGEN_B",
  "T_OP_GETBIT_B", "T_OP_SETRM", "T_OP_CBITS_B", "T_OP_SHB", "T_OP_MSAD",
  "T_OP_MAD_U16", "T_OP_MADSH_U16", "T_OP_MAD_S16", "T_OP_MADSH_M16",
  "T_OP_MAD_U24", "T_OP_MAD_S24", "T_OP_MAD_F16", "T_OP_MAD_F32",
  "T_OP_SEL_B16", "T_OP_SEL_B32", "T_OP_SEL_S16", "T_OP_SEL_S32",
  "T_OP_SEL_F16", "T_OP_SEL_F32", "T_OP_SAD_S16", "T_OP_SAD_S32",
  "T_OP_SHRM", "T_OP_SHLM", "T_OP_SHRG", "T_OP_SHLG", "T_OP_ANDG",
  "T_OP_DP2ACC", "T_OP_DP4ACC", "T_OP_WMM", "T_OP_WMM_ACCU", "T_OP_RCP",
  "T_OP_RSQ", "T_OP_LOG2", "T_OP_EXP2", "T_OP_SIN", "T_OP_COS",
  "T_OP_SQRT", "T_OP_HRSQ", "T_OP_HLOG2", "T_OP_HEXP2", "T_OP_ISAM",
  "T_OP_ISAML", "T_OP_ISAMM", "T_OP_SAM", "T_OP_SAMB", "T_OP_SAML",
  "T_OP_SAMGQ", "T_OP_GETLOD", "T_OP_CONV", "T_OP_CONVM", "T_OP_GETSIZE",
  "T_OP_GETBUF", "T_OP_GETPOS", "T_OP_GETINFO", "T_OP_DSX", "T_OP_DSY",
  "T_OP_GATHER4R", "T_OP_GATHER4G", "T_OP_GATHER4B", "T_OP_GATHER4A",
  "T_OP_SAMGP0", "T_OP_SAMGP1", "T_OP_SAMGP2", "T_OP_SAMGP3",
  "T_OP_DSXPP_1", "T_OP_DSYPP_1", "T_OP_RGETPOS", "T_OP_RGETINFO",
  "T_OP_BRCST_A", "T_OP_QSHUFFLE_BRCST", "T_OP_QSHUFFLE_H",
  "T_OP_QSHUFFLE_V", "T_OP_QSHUFFLE_DIAG", "T_OP_TCINV", "T_OP_LDG",
  "T_OP_LDG_A", "T_OP_LDG_K", "T_OP_LDL", "T_OP_LDP", "T_OP_STG",
  "T_OP_STG_A", "T_OP_STL", "T_OP_STP", "T_OP_LDIB", "T_OP_G2L",
  "T_OP_L2G", "T_OP_PREFETCH", "T_OP_LDLW", "T_OP_STLW", "T_OP_RESFMT",
  "T_OP_RESINFO", "T_OP_ATOMIC_ADD", "T_OP_ATOMIC_SUB", "T_OP_ATOMIC_XCHG",
  "T_OP_ATOMIC_INC", "T_OP_ATOMIC_DEC", "T_OP_ATOMIC_CMPXCHG",
  "T_OP_ATOMIC_MIN", "T_OP_ATOMIC_MAX", "T_OP_ATOMIC_AND",
  "T_OP_ATOMIC_OR", "T_OP_ATOMIC_XOR", "T_OP_RESINFO_B", "T_OP_LDIB_B",
  "T_OP_STIB_B", "T_OP_ATOMIC_B_ADD", "T_OP_ATOMIC_B_SUB",
  "T_OP_ATOMIC_B_XCHG", "T_OP_ATOMIC_B_INC", "T_OP_ATOMIC_B_DEC",
  "T_OP_ATOMIC_B_CMPXCHG", "T_OP_ATOMIC_B_MIN", "T_OP_ATOMIC_B_MAX",
  "T_OP_ATOMIC_B_AND", "T_OP_ATOMIC_B_OR", "T_OP_ATOMIC_B_XOR",
  "T_OP_ATOMIC_S_ADD", "T_OP_ATOMIC_S_SUB", "T_OP_ATOMIC_S_XCHG",
  "T_OP_ATOMIC_S_INC", "T_OP_ATOMIC_S_DEC", "T_OP_ATOMIC_S_CMPXCHG",
  "T_OP_ATOMIC_S_MIN", "T_OP_ATOMIC_S_MAX", "T_OP_ATOMIC_S_AND",
  "T_OP_ATOMIC_S_OR", "T_OP_ATOMIC_S_XOR", "T_OP_ATOMIC_G_ADD",
  "T_OP_ATOMIC_G_SUB", "T_OP_ATOMIC_G_XCHG", "T_OP_ATOMIC_G_INC",
  "T_OP_ATOMIC_G_DEC", "T_OP_ATOMIC_G_CMPXCHG", "T_OP_ATOMIC_G_MIN",
  "T_OP_ATOMIC_G_MAX", "T_OP_ATOMIC_G_AND", "T_OP_ATOMIC_G_OR",
  "T_OP_ATOMIC_G_XOR", "T_OP_LDGB", "T_OP_STGB", "T_OP_STIB", "T_OP_LDC",
  "T_OP_LDLV", "T_OP_GETSPID", "T_OP_GETWID", "T_OP_GETFIBERID",
  "T_OP_STC", "T_OP_STSC", "T_OP_SHFL", "T_OP_BAR", "T_OP_FENCE",
  "T_OP_SLEEP", "T_OP_ICINV", "T_OP_DCCLN", "T_OP_DCINV", "T_OP_DCFLU",
  "T_OP_CCINV", "T_OP_LOCK", "T_OP_UNLOCK", "T_OP_ALIAS", "T_RAW",
  "T_OP_PRINT", "T_TYPE_F16", "T_TYPE_F32", "T_TYPE_U16", "T_TYPE_U32",
  "T_TYPE_S16", "T_TYPE_S32", "T_TYPE_U8", "T_TYPE_U8_32", "T_TYPE_U64",
  "T_UNTYPED", "T_TYPED", "T_MIXED", "T_UNSIGNED", "T_LOW", "T_HIGH",
  "T_1D", "T_2D", "T_3D", "T_4D", "T_LT", "T_LE", "T_GT", "T_GE", "T_EQ",
  "T_NE", "T_S2EN", "T_SAMP", "T_TEX", "T_BASE", "T_OFFSET", "T_UNIFORM",
  "T_NONUNIFORM", "T_IMM", "T_NAN", "T_INF", "T_A0", "T_A1", "T_P0", "T_W",
  "T_CAT1_TYPE_TYPE", "T_INSTR_TYPE", "T_MOD_TEX", "T_MOD_MEM", "T_MOD_RT",
  "T_MOD_XOR", "T_MOD_UP", "T_MOD_DOWN", "T_MOD_RUP", "T_MOD_RDOWN", "'-'",
  "','", "'('", "')'", "'='", "':'", "'!'", "'#'", "'.'", "'a'", "'o'",
  "'p'", "'s'", "'v'", "'+'", "'<'", "'g'", "'['", "']'", "'c'", "'l'",
  "'u'", "'k'", "'w'", "'r'", "'>'", "'h'", "$accept", "shader", "$@1",
  "headers", "header", "const_val", "localsize_header", "const_header",
  "buf_header_init_val", "buf_header_init_vals", "buf_header_addr_reg",
  "buf_header", "$@2", "invocationid_header", "wgid_header",
  "numwg_header", "branchstack_header", "pvtmem_header", "localmem_header",
  "earlypreamble_header", "in_header", "out_header", "tex_header",
  "fullnop_start_section", "fullnop_end_section", "fullsync_start_section",
  "fullsync_end_section", "iflag", "iflags", "instrs", "instr", "label",
  "cat0_src1", "cat0_src2", "cat0_immed", "cat0_instr", "$@3", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13",
  "$@14", "$@15", "$@16", "cat1_opc", "cat1_src", "cat1_movmsk", "$@17",
  "mova_src", "cat1_mova1", "$@18", "cat1_mova", "$@19", "cat1_swz",
  "$@20", "cat1_gat", "$@21", "cat1_sct", "$@22", "cat1_instr",
  "cat2_opc_1src", "cat2_opc_2src_cnd", "cat2_opc_2src", "cond",
  "cat2_instr", "cat3_dp_signedness", "cat3_dp_pack", "cat3_opc",
  "cat3_imm_reg_opc", "cat3_wmm", "cat3_dp", "cat3_instr", "cat4_opc",
  "cat4_instr", "cat5_opc_dsxypp", "cat5_opc_isam", "cat5_opc",
  "cat5_flag", "cat5_flags", "cat5_samp", "cat5_tex", "cat5_type",
  "cat5_a1", "cat5_samp_tex", "cat5_samp_tex_all", "cat5_instr",
  "cat6_typed", "cat6_dim", "cat6_type", "cat6_imm_offset", "cat6_offset",
  "cat6_dst_offset", "cat6_immed", "cat6_a6xx_global_address_pt3",
  "cat6_a6xx_global_address_pt2", "cat6_a6xx_global_address", "cat6_load",
  "$@23", "$@24", "$@25", "$@26", "$@27", "$@28", "$@29", "$@30",
  "cat6_store", "$@31", "$@32", "$@33", "$@34", "$@35", "cat6_loadib",
  "$@36", "cat6_storeib", "$@37", "cat6_prefetch", "$@38",
  "cat6_atomic_opc", "cat6_a3xx_atomic_opc", "cat6_a6xx_atomic_opc",
  "cat6_a3xx_atomic_s", "cat6_a6xx_atomic_g", "cat6_atomic_l",
  "cat6_atomic", "cat6_ibo_opc_1src", "cat6_ibo_opc_ldgb",
  "cat6_ibo_opc_stgb", "cat6_ibo", "$@39", "cat6_id_opc", "cat6_id",
  "cat6_bindless_base", "cat6_bindless_mode", "cat6_reg_or_immed",
  "cat6_bindless_ibo_opc_1src", "cat6_bindless_ibo_opc_2src",
  "cat6_bindless_ibo_opc_3src", "cat6_bindless_ibo_opc_3src_dst",
  "cat6_bindless_ibo", "cat6_bindless_ldc_opc", "cat6_bindless_ldc_middle",
  "cat6_bindless_ldc", "const_dst", "cat6_stc", "$@40", "$@41",
  "cat6_shfl_mode", "cat6_shfl", "$@42", "cat6_todo", "cat6_instr",
  "cat7_scope", "cat7_scopes", "cat7_barrier", "$@43", "$@44",
  "cat7_data_cache", "cat7_alias_src", "cat7_alias_scope", "cat7_instr",
  "$@45", "raw_instr", "meta_print_regs", "meta_print_reg",
  "meta_print_start", "meta_print", "src_gpr", "src_a0", "src_a1",
  "src_p0", "src", "dst", "const", "dst_reg_flag", "dst_reg_flags",
  "dst_reg", "src_reg_flag", "src_reg_flags", "src_reg", "src_reg_gpr",
  "src_const", "src_reg_or_const", "src_reg_or_const_or_rel",
  "src_reg_or_const_or_rel_or_imm", "src_reg_or_rel_or_imm", "uoffset",
  "offset", "src_uoffset", "relative_gpr_src", "relative_gpr_dst",
  "relative_const", "relative", "immediate_cat1", "immediate",
  "flut_immed", "integer", "float", "type", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1029)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-4)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
   -1029,    50,  1087, -1029,    36,  -286,    36,  -280,  -256,  -230,
      36,  -219,  -201,  -198,    36,    36, -1029,  1038,  1087, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029,   143,  -192,   154, -1029,   172,
     106,   176, -1029,   175,   187,   190, -1029, -1029,  -154, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029,   198, -1029, -1029, -1029, -1029,   647,  1492,  1001,
   -1029, -1029, -1029,  -144, -1029, -1029, -1029,    36,  -137,  -130,
    -124,  -118,  -104,  -101,   -89,   -81,   -77, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029,   -65, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029,   -62, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029,   -40,   -12,    -6,   -22,   -19,   -15,    -2,    14, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029,    45, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
     197,    15,   197, -1029,   197,   197,   197,    17, -1029,   197,
   -1029,    21,    22,    21, -1029, -1029, -1029, -1029, -1029, -1029,
      27,    27,    27, -1029, -1029, -1029, -1029,    29,    27,    27,
   -1029,    29, -1029,    27,    27,    27,    27, -1029,    31, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,   383, -1029,
    -144,    48,    36,   385,    36, -1029, -1029, -1029, -1029,   395,
     397,   401,  -281,  -281,  -281,    66,  -281,  -281,    54,    54,
      54,  -281,    54,    70,    54,    54,    81,    73,    74,    91,
      95,    97,    99,   102,    29,    29,    29,    29,    29,    29,
      29,    29,    29,    27,    55,    29,    29,    27,    29,    29,
      29,    72,    85,    85,    93, -1029,    83, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029,    84, -1029,   580,   170,   104,
     111,   114,   301,   115,   117,   120,   122,  -196,   118,   126,
     935,    21,   197,   875,   132,   132,  -122,   136,   136,   136,
     268,   136,   136,   136,   197,   136,   136,   136,   136,    34,
   -1029, -1029,    36,   144,   145, -1029,   151, -1029,   148,   157,
     159, -1029,   180,   163,   171,   173, -1029, -1029,   216, -1029,
     177,   178,    52, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,   197,
     197,   156,   197,   197,   164,   166,   168,   162,   136,   179,
     197,   169,   136,   197,   181,   182,   133,  -225,    85, -1029,
   -1029,  -171,   201,   206, -1029, -1029,    60,    60,   880, -1029,
   -1029, -1029, -1029, -1029, -1029,   197,   880,   183,   910,   258,
   -1029, -1029,   -73,   197,   880, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029,   193,    21,   268,
     197,   197, -1029, -1029,   -92,    29,    29,    29, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,   197,    29,
      29, -1029,    29,    29,    29,    29,   195,   196,   200,   204,
   -1029, -1029,    36, -1029,    36,   542,   554,    66, -1029,    54,
    -261,  -261, -1029, -1029,    54,    54,    54, -1029, -1029,    54,
     197,    60,    60,   197,   197,   197,   212,   214,   213,   228,
     230,   217,   221,   226,   232,    29,   174,   249,   234,    29,
     252,   239,   241, -1029, -1029, -1029, -1029, -1029,    29, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,   209,  -244,
    -244, -1029, -1029, -1029, -1029, -1029, -1029, -1029,   218,   263,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,    42,   264,
     265,   281, -1029, -1029, -1029, -1029, -1029, -1029, -1029,   699,
     167, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029,    66,   717,   777, -1029, -1029, -1029, -1029,
   -1029,   286,   296,   299,   174, -1029,   300, -1029, -1029, -1029,
     304, -1029, -1029, -1029,   308, -1029,   653,   132,   312,   313,
     315, -1029, -1029, -1029, -1029,   316,   317,   322,   327,   323,
     324,   329,   332,   333,   334,    66,   341,   321,    90,   356,
   -1029,   355,   357,   359, -1029, -1029,   374,   363,   364, -1029,
   -1029, -1029, -1029, -1029, -1029,   645, -1029, -1029, -1029,   365,
     367,   370,   369,   371,    20,   353,   375,   174,   253,   174,
     174,   372,  -207,   361,   174,   381,   376,    20,    20,   170,
     399,    66,    66, -1029,   373,   378,   406,   408, -1029,   392,
     394,   307,   396,   415,   414,   437,    56, -1029, -1029, -1029,
   -1029,   421,    66, -1029, -1029,   880,   880,   253,   253,   325,
     910, -1029,   197, -1029,   653,    13,    66,    66,    66,   409,
      66,    66,    66,    66,    66,    66,   418,   419,   420,   428,
   -1029, -1029,    36,    66,    66,   776, -1029,    54,    54, -1029,
     197,   325,   197,   416,   424,   422,   433, -1029,   436,   438,
    -244,   442,   153,   423,  -206,  -206,    66,    90, -1029,   443,
   -1029,   439,  -206,    66,   446,   459,   460,   453,   430, -1029,
   -1029, -1029, -1029,  -244,  -244, -1029, -1029, -1029, -1029, -1029,
    -244,  -244,   461,   478, -1029,   479,   482, -1029,   484,   485,
     486,   487,   488,   489, -1029, -1029,   491, -1029, -1029,   492,
     490,   496,   497,   477,   197, -1029,   499,   500,   501,   502,
     -11,    66,   -11,    90,   494,   493,   508,   510, -1029, -1029,
     514,   515,   516,   174,   253,    66,   518,   174,   174,   503,
     519,   149,    90,   504, -1029,   507,   197, -1029,   525,   174,
     511,   481,    66,   529,   534,   174,    66,   475,   517,   521,
     522, -1029, -1029, -1029,   880,   183,   910,   928,   253,   653,
      13,   558,    13,   523,   528,   532,    90,   540,   533,   -11,
     -11,   -11,   -11,   543,   543,   543,   197,   544,   531, -1029,
      36, -1029, -1029,    66,   325,   325,   197,  -207,   535, -1029,
     538,  -207,  -207,   564,   174,   174, -1029,  -119, -1029,   579,
     582,   583,    66,  -207,   584,   576,   537,   325,   928,   595,
     197, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,   596,
     597,   609,   611, -1029, -1029,   612, -1029, -1029,   613,   197,
     197,   197,   610,   599,   617,   197,   325,   325,   197,   650,
   -1029, -1029, -1029, -1029,   -11,   618, -1029,   629,   635,   636,
     637,   621,   640,   625,   626,   628,   174,   642,  -244,    90,
     633, -1029,   174,   174,   634, -1029,   631,   174,   928, -1029,
     651,   652,    90,   654,   910, -1029,   657,  -216,   667,    67,
      67,   659,   660,   664, -1029,   661,    90,   669,   676,   678,
     679, -1029,   197,   681,  1025,   325,   325,   197,   682,   928,
     174,   683,   684,   686,   928,   685, -1029,    66,   688,   689,
     665,   690,   691,   677,   695,    66,    66, -1029,   320, -1029,
      13, -1029, -1029, -1029, -1029, -1029,   696, -1029,   694,   693,
     174,    90,   680,    90,    90,    90,    90, -1029,   697,   712,
   -1029,   698,   716,   928, -1029,  -207,   928,   928,   928, -1029,
     703,  -244,   928,   928,   928,   928,   928,   719,   928, -1029,
   -1029, -1029, -1029, -1029, -1029,   667,   704,   705,   722,   706,
     724, -1029,   725,   597,   597, -1029,    66,   325,   325, -1029,
     709, -1029, -1029, -1029,   713,   714, -1029, -1029,   741, -1029,
   -1029,   174, -1029,    90,    90,   174,   731,   174,    90,   736,
     759,   760, -1029, -1029,   761,    66,   751,   766,   767,   752,
     753, -1029,   174,   768, -1029,    90,    90,  1116,   928, -1029,
      66,   174,   174,   772,   773,   774,    90, -1029, -1029,   778,
   -1029, -1029,   775,   779,   174,   174,   174,   780,    66,   174,
     174, -1029,   782, -1029,   174,   783, -1029, -1029,   174, -1029,
    1122,   784,   785,   174,    66, -1029, -1029
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     4,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    40,    56,     4,     6,
       7,     8,     9,    10,    11,    12,    16,    17,    18,    13,
      14,    15,    20,    22,    19,     0,     0,     0,    31,     0,
       0,     0,    37,     0,     0,     0,    38,    39,     0,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,   508,     0,    71,    72,    73,    74,    56,     0,    56,
      59,    70,    68,     0,    69,     5,    21,     0,     0,    30,
       0,     0,     0,     0,     0,     0,     0,    75,   512,    57,
      82,    83,    85,    87,     0,    91,    93,    95,    97,    99,
     101,   102,   104,   105,   106,   107,   108,   109,   110,   112,
     113,   114,   115,     0,   116,   118,   119,   121,   122,   123,
     124,     0,     0,     0,     0,     0,     0,     0,     0,   174,
     175,   176,   177,   158,   168,   154,   171,   159,   160,   161,
     162,   163,   178,   179,   180,   181,   169,   170,   182,   183,
     184,   185,   155,   186,   187,   164,   188,   172,   173,   189,
     190,   191,   165,   157,   156,   192,   193,   194,   195,   196,
     197,   198,   166,   167,   199,   200,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   237,   238,   235,
     236,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   254,   255,   280,   281,   282,
     283,   284,   285,   286,   320,   339,   341,   343,   347,   345,
     354,   356,   360,   358,   364,   465,   466,   368,   349,   362,
     467,   409,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   427,   440,   439,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,   438,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   410,
     411,   366,   445,   351,   416,   417,   418,   453,   455,   463,
     487,   489,   501,   503,   491,   492,   493,   502,   504,   505,
     506,    60,     0,   146,   147,   148,   149,   150,   151,    61,
       0,     0,     0,    62,     0,     0,     0,     0,    63,     0,
      64,   298,   298,   298,    65,   468,   470,   469,   471,   472,
       0,     0,     0,   407,   408,   406,   473,     0,     0,     0,
     474,     0,   475,     0,     0,     0,     0,   477,     0,   476,
     478,   479,   480,    66,   499,   500,    67,    58,     0,   513,
     509,     0,     0,     0,    28,    33,    34,    35,    36,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   485,   485,     0,   522,     0,   527,   528,   529,
     530,   531,   523,   524,   525,     0,   534,   532,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   298,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     511,   510,     0,     0,     0,    25,    26,    32,     0,     0,
       0,    77,     0,     0,     0,     0,   602,   604,     0,    89,
       0,     0,     0,    96,    98,   100,   103,   111,   125,   117,
     120,   131,   136,   138,   127,   128,   140,   142,   144,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   485,   488,
     490,     0,     0,     0,   533,   535,     0,     0,     0,   201,
     202,   203,   204,   205,   206,     0,     0,     0,     0,     0,
     210,   211,     0,     0,     0,   293,   287,   292,   296,   294,
     295,   297,   288,   289,   290,   291,   299,     0,   298,     0,
       0,     0,   321,   322,     0,     0,     0,     0,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   327,     0,     0,
       0,   419,     0,     0,     0,     0,     0,     0,     0,     0,
     333,    23,     0,    29,    28,     0,     0,     0,    76,     0,
       0,     0,   603,   605,     0,     0,     0,    81,    80,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   457,   458,   459,   460,   461,     0,   462,
     484,   483,   481,   482,   486,   496,   497,   498,     0,   560,
     560,   514,   526,   536,   537,   538,   539,   540,     0,     0,
     580,   581,   582,   583,   584,   515,   516,   517,     0,     0,
       0,     0,   152,   518,   519,   520,   521,   543,   547,   541,
       0,   549,   550,   551,   129,   571,   572,   552,   130,   573,
     153,   590,   591,   592,   593,   594,   595,   596,   597,   598,
     599,   600,   601,     0,     0,     0,   554,   207,   556,   587,
     585,     0,     0,     0,     0,   557,     0,   558,   559,   545,
       0,   546,   212,   213,     0,   253,     0,     0,     0,     0,
     316,   323,   324,   325,   326,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      27,     0,     0,     0,    84,    79,     0,     0,     0,    90,
      92,    94,   126,   132,   137,     0,   133,   134,   139,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   560,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   562,     0,     0,     0,     0,   606,     0,
       0,     0,     0,     0,     0,     0,     0,   542,   544,   548,
     553,     0,     0,   589,   555,     0,     0,     0,     0,     0,
       0,   312,     0,   302,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     425,   426,     0,     0,     0,     0,    78,     0,     0,   135,
       0,     0,     0,     0,     0,   451,     0,   450,     0,     0,
     560,     0,     0,     0,   560,   560,     0,     0,   329,     0,
     328,     0,   560,     0,     0,     0,     0,     0,     0,   563,
     561,   568,   567,   560,   560,   578,   579,   607,   574,   575,
     560,   560,     0,     0,   586,     0,     0,   209,     0,     0,
       0,     0,     0,     0,   300,   301,   306,   307,   315,   304,
       0,     0,     0,     0,     0,   414,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    86,    88,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   331,     0,     0,   330,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   576,   577,   588,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   420,   420,   420,     0,     0,     0,   449,
       0,    41,    42,     0,     0,     0,     0,   560,     0,   452,
       0,   560,   560,     0,     0,     0,   338,     0,   332,     0,
       0,     0,     0,   560,     0,     0,     0,     0,     0,     0,
       0,   566,   570,   569,   565,   208,   239,   240,   241,     0,
     560,   306,   307,   308,   318,   304,   305,   314,   304,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     423,   424,   422,   446,     0,     0,    24,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   560,     0,
       0,   337,     0,     0,     0,   369,     0,     0,     0,   352,
       0,     0,     0,     0,     0,   564,     0,     0,     0,     0,
       0,     0,     0,     0,   412,     0,     0,     0,     0,     0,
       0,   421,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   464,     0,   242,
       0,   309,   303,   310,   311,   317,   304,   313,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   447,     0,     0,
     141,     0,     0,     0,   342,   560,     0,     0,     0,   357,
       0,   560,     0,     0,     0,     0,     0,     0,     0,   454,
     456,   507,   494,   495,   319,     0,     0,     0,     0,     0,
       0,   441,     0,   560,   560,   448,     0,     0,     0,   340,
       0,   348,   346,   355,     0,     0,   361,   359,     0,   350,
     363,     0,   353,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   143,   145,     0,     0,     0,     0,     0,     0,
       0,   404,     0,     0,   442,     0,     0,     0,     0,   336,
       0,     0,     0,     0,     0,     0,     0,   443,   444,     0,
     344,   334,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   405,     0,   413,     0,     0,   365,   367,     0,   415,
       0,     0,     0,     0,     0,   403,    43
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1029, -1029, -1029,  1119, -1029,    -4, -1029, -1029, -1029,   526,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,  1071, -1029,
    1073, -1029,   -69,   509,  -361, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029,   598, -1029, -1029,   512, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029,  -269,   297,  -784,  -444,  -851,   302,
    -815, -1029,   236,   311,   881,   266,  -893,  -726,  -733, -1029,
   -1029,   194, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029,  -724,  -845,    37,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,  -455, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,  -422, -1029,
   -1029, -1029, -1029, -1029, -1029, -1029, -1029, -1029,   769, -1029,
   -1029, -1029,  -752, -1029,  -861, -1029,   -90,  -441,  -595, -1029,
     707,  -337, -1029,  -531,  -550, -1029, -1029,  -743,  -523,  -544,
    -788, -1028,  -651,  -848,   591, -1029, -1029,  -555,  -627,  -552,
     427,  -404,   331,   581
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,    17,    18,   495,    19,    20,   496,   497,
     394,    21,    79,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    63,    64,    65,    66,    67,    68,    69,
      70,    71,   503,   787,   513,   331,   402,   403,   404,   634,
     406,   407,   408,   409,   410,   411,   412,   414,   415,   639,
     332,   702,   333,   640,   794,   334,   641,   335,   642,   336,
     643,   337,   644,   338,   645,   339,   340,   341,   342,   565,
     343,   468,   573,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   471,   472,  1061,  1062,   590,  1164,  1063,
    1064,   354,   477,   595,   481,   898,   899,   973,   618,  1101,
    1036,   891,   355,   424,   425,   426,   428,   427,   435,   438,
    1154,   356,   429,   430,   432,   431,   436,   357,   433,   358,
     437,   359,   434,   360,   361,   362,   363,   364,   365,   366,
     367,   368,   369,   370,  1008,   371,   372,  1080,  1016,   869,
     373,   374,   375,   376,   377,   378,   619,   379,   886,   380,
     439,   440,   668,   381,   441,   382,   383,   548,   549,   384,
     442,   443,   385,  1201,   678,   386,   444,    72,   389,   390,
      73,    74,   703,   704,   705,   706,   707,   456,   708,   457,
     458,   459,   709,   744,   711,   750,   712,   713,   736,   737,
     746,   823,   900,  1116,   715,   460,   716,   717,   718,   738,
     739,   740,   833,   607
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      36,   509,    38,   461,   851,   463,    42,   464,   465,   466,
      46,    47,   469,   747,   797,   797,   748,   555,   745,   749,
     681,   550,   742,   506,   507,   710,   710,   735,   824,   825,
     755,   591,  1115,   714,   714,   735,   710,   506,   507,    32,
      33,    34,   866,   735,   743,   506,   507,   828,   514,   515,
       3,   517,   445,   519,   520,   506,   507,   501,   637,   506,
     507,   828,   931,   506,   507,   893,    37,   681,   682,   506,
     507,   937,    39,   391,   681,   502,   446,   785,   447,   448,
     449,   450,   451,   474,   475,   620,   683,   684,   685,   686,
     687,   688,   689,   506,   507,   786,    40,   681,   690,   691,
     692,   693,   933,   939,   928,   929,   821,  1018,   638,   694,
     795,   795,   935,    81,    82,   839,   570,   571,   796,   796,
     822,   696,    41,   940,   941,   942,   674,   944,   945,   946,
     947,   948,   949,    43,  1091,   587,   506,   507,  1094,  1095,
     839,   670,   669,   821,   821,   671,    76,   611,   672,   673,
    1106,    44,   719,   719,    45,   840,   681,   897,   972,    77,
     681,   682,    78,   976,  1075,  1076,  1077,  1078,   879,   975,
     981,   675,   676,   677,   681,   682,   980,   445,   837,    80,
     840,   681,    84,   844,    83,  1115,  1115,  1067,   592,   593,
     681,   682,   646,   647,    85,   649,   650,    86,   688,   689,
     839,    87,   586,   657,   445,    88,   660,   388,  1057,   683,
     684,   685,   686,   687,   688,   689,   392,  1066,  1017,   632,
     633,   893,   393,   783,   761,   762,   763,   764,   741,   395,
     447,   448,   449,   450,   451,   396,   754,   719,   719,  1132,
     840,   752,   753,   974,   974,  1099,  1100,  1060,  1065,   397,
    1068,   974,   398,   759,   760,  1059,  1162,  1162,  1162,  1162,
     681,   682,   987,   988,   399,   681,  1161,  1163,   784,   989,
     990,   768,   400,   789,   790,   791,   401,   892,   792,   683,
     684,   685,   686,   687,   683,   684,   685,   686,   687,   688,
    1081,  1082,  1220,   405,   832,   747,   413,   839,   748,   930,
     745,   926,   927,   793,  1165,  1167,   799,   800,   801,  1105,
     632,   633,   917,   852,   735,   735,   892,   892,   416,   757,
    1013,  1014,  1015,   506,   507,   417,  1159,   681,   682,   841,
     418,   961,   681,  1066,   504,   505,   419,   510,   511,   420,
     934,   935,   516,   421,  1162,  1204,   683,   684,   685,   686,
     687,   683,   684,   685,   686,   687,   422,   885,   690,   691,
     692,   693,   905,   906,   616,  1239,  1240,  1166,  1166,   694,
     508,   620,   423,   462,   871,   467,   829,   830,   907,   470,
     473,   452,   453,   454,   508,   476,    35,   480,   493,   489,
     490,   719,   831,   494,   934,   935,   695,   696,   697,   492,
     887,   498,   508,   499,   696,   617,   831,   500,  1166,   518,
     508,   512,   698,   887,   887,  1202,   508,   909,   910,   455,
     521,   539,  1199,  1200,   522,   523,   695,   696,   697,   699,
     546,   524,   922,   892,   700,   525,   701,   526,   925,   527,
     508,   747,   528,   547,   748,  1058,   745,  1145,   552,   553,
    1055,   551,   620,   620,   620,   556,   620,   620,   620,   620,
     620,   620,   557,   735,   710,   558,   566,   892,   567,   955,
     956,   568,  1056,   569,  1088,  1089,   572,   574,   663,   664,
     665,   666,   667,   508,   589,   695,   696,   697,   621,   695,
     696,   697,   620,   910,   594,   622,  1111,  1110,   623,   620,
     625,  1035,   624,   695,   696,   697,   452,   453,   454,   626,
     695,   696,   697,   627,   629,   932,   958,   959,   628,   695,
     696,   697,   630,   654,   631,   648,  1128,  1129,   635,   636,
     651,  1203,   652,   452,   453,   454,   699,   679,   653,   658,
    1225,   700,   680,   960,   756,   962,   656,   620,   781,   871,
     661,   662,   699,   775,   776,   778,  1153,   700,   777,   747,
     782,  1029,   748,   802,   745,   803,   812,   820,   910,   598,
     599,   600,   601,   602,   603,   604,   605,   606,  1046,   805,
     804,   806,  1050,   826,   807,  1180,  1181,  1184,   808,   695,
     696,   697,  1189,   809,   695,   696,   697,   478,   479,   810,
     813,   814,   871,   816,   482,   483,   817,  1007,   818,   485,
     486,   487,   488,   447,   448,   449,   450,   451,   779,  1087,
     838,   559,   560,   561,   562,   563,   564,   892,   827,   834,
     835,  1219,   700,   836,  1221,  1222,  1223,   845,   620,  1041,
    1226,  1227,  1228,  1229,  1230,   838,  1232,   846,   506,   507,
     847,   848,   681,   682,   838,   849,   695,   696,   697,   850,
     681,   695,   696,   697,   854,   853,   855,  1242,  1243,   538,
     508,   867,   698,   542,   856,   857,   688,   689,   859,  1083,
     858,   860,   861,   690,   691,   692,   693,   862,   870,  1090,
     863,   864,   865,   868,   694,   871,   701,    53,    54,    55,
      56,    57,    58,    59,    60,   838,  1270,   872,   871,   873,
     875,   874,   876,  1113,   877,   878,   880,   890,   881,   894,
     895,   882,   871,   888,   902,   683,   684,   685,   686,   687,
     896,   901,  1121,  1122,  1123,   883,   889,   884,  1127,   903,
     908,  1130,   913,  1191,   914,   915,   904,   916,   911,   918,
     920,   620,   620,   912,   719,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   871,   919,   871,
     871,   871,   871,   921,   924,   943,   950,   951,   952,   953,
     506,   507,   957,   963,   681,   682,   965,   971,   986,   596,
     597,   964,   608,   609,   610,  1177,   612,   613,   614,   615,
    1182,   966,   838,   967,   985,   968,   979,   977,   688,   689,
     970,   978,  1241,   982,   991,   721,   722,   723,   724,   725,
     726,   727,   728,   729,   730,   731,   732,   983,   984,   871,
     871,   992,   993,   994,   871,   995,   996,   997,   998,   999,
    1000,  1259,  1001,  1002,  1006,  1020,  1021,  1045,  1003,   655,
    1051,   871,   871,   659,  1004,  1005,  1271,  1009,  1010,  1011,
    1012,  1022,   871,   870,  1023,  1024,  1025,  1026,   954,  1030,
    1034,  1033,  1039,  1027,  1285,  1040,  1042,  1031,  1032,  1044,
    1047,  1037,  1038,   506,   507,  1048,   935,   681,   682,  1043,
    1296,  1073,  1052,  1069,  1070,  1049,  1053,  1054,  1071,  1074,
    1085,  1079,  1084,  1092,  1093,  1109,   683,   684,   685,   686,
     687,   688,   689,   506,   507,  1096,   870,   681,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
    1102,   506,   507,  1103,  1104,  1107,   683,   684,   685,   686,
     687,   688,   689,  1108,  1097,  1098,  1112,  1114,   721,   722,
     723,   724,   725,   726,   727,   728,   729,   730,   731,   732,
    1117,   822,  1118,  1119,  1120,  1125,   721,   722,   723,   724,
     725,   726,   727,   728,   729,   730,   731,   732,  1124,  1131,
    1134,   695,   696,   697,  1126,  1133,  1135,  1136,  1137,  1138,
    1019,  1139,  1140,  1144,  1141,   508,  1142,   698,  1147,  1151,
    1150,    -3,  1155,  1156,   696,  1158,  1143,    48,  1160,   870,
    1168,  1169,  1148,  1149,   699,  1170,  1086,  1152,  1178,   700,
    1173,   701,   870,    49,    50,    51,    52,  1174,  1171,  1175,
    1176,  1179,  1194,  1183,  1186,  1187,   870,  1188,  1190,  1192,
    1193,  1195,  1196,  1072,    48,  1197,  1198,  1205,  1210,  1217,
    1185,    53,    54,    55,    56,    57,    58,    59,    60,  1207,
      49,    50,    51,    52,  1206,  1215,  1216,  1218,  1224,   842,
    1231,  1233,  1234,  1235,  1236,  1237,  1238,  1244,  1245,  1246,
    1208,   870,  1252,   870,   870,   870,   870,  1255,    53,    54,
      55,    56,    57,    58,    59,    60,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,  1247,
    1256,  1257,  1258,   695,   696,   697,  1260,  1261,  1262,  1266,
    1263,  1264,  1269,  1274,  1275,  1276,  1279,   508,  1292,   733,
    1280,  1284,  1278,  1288,  1290,  1293,  1146,    75,    89,  1294,
     788,  1248,   387,   870,   870,  1251,   699,  1253,   870,  1157,
     780,   700,   936,   734,   798,   720,   969,   938,  1028,   491,
     751,   843,  1265,  1172,   554,   870,   870,   923,     0,     0,
     758,  1272,  1273,     0,     0,     0,   870,     0,     0,     0,
       0,     0,     0,     0,  1281,  1282,  1283,     0,     0,  1286,
    1287,   575,     0,   576,  1289,     0,     0,     0,  1291,     0,
       0,   577,     0,  1295,   578,     0,   579,   580,  1209,     0,
    1211,  1212,  1213,  1214,   581,     0,   695,   696,   697,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     508,     0,   733,     0,   582,   583,   584,   585,   588,     0,
       0,     0,     0,     0,     0,     0,   695,   696,   697,   699,
       0,   575,   484,   576,   700,     0,   734,     0,     0,     0,
     508,   577,   733,     0,   578,     0,   579,   580,     0,     0,
    1249,  1250,     0,     0,   581,  1254,     0,     0,   508,   699,
     733,     0,     0,     0,   700,     0,   734,     0,     0,     0,
       0,     0,  1267,  1268,   582,   583,   584,   585,     0,     0,
      61,    62,     0,  1277,   734,   529,   530,   531,   532,   533,
     534,   535,   536,   537,     0,     0,   540,   541,     0,   543,
     544,   545,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    61,    62,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   765,   766,   767,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     769,   770,     0,   771,   772,   773,   774,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   811,     0,     0,     0,
     815,     0,     0,     0,     0,     0,     0,     0,     0,   819,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330
};

static const yytype_int16 yycheck[] =
{
       4,   405,     6,   340,   756,   342,    10,   344,   345,   346,
      14,    15,   349,   568,   641,   642,   568,   458,   568,   569,
       7,   443,   566,     3,     4,   556,   557,   558,   679,   680,
     574,   475,  1060,   556,   557,   566,   567,     3,     4,     3,
       4,     5,   775,   574,   567,     3,     4,     5,   409,   410,
       0,   412,     7,   414,   415,     3,     4,   338,     6,     3,
       4,     5,   850,     3,     4,   808,   352,     7,     8,     3,
       4,   855,   352,    77,     7,   356,    31,   338,    33,    34,
      35,    36,    37,   352,   353,   489,    26,    27,    28,    29,
      30,    31,    32,     3,     4,   356,   352,     7,    38,    39,
      40,    41,   854,   855,   847,   848,   350,   952,   512,    49,
     641,   642,   328,     7,     8,   710,   312,   313,   641,   642,
     364,   337,   352,   856,   857,   858,   548,   860,   861,   862,
     863,   864,   865,   352,  1027,   472,     3,     4,  1031,  1032,
     735,   366,   546,   350,   350,   370,     3,   484,   373,   374,
    1043,   352,   556,   557,   352,   710,     7,   364,   364,   351,
       7,     8,     8,   896,  1009,  1010,  1011,  1012,   795,   895,
     903,   342,   343,   344,     7,     8,   902,     7,   709,     7,
     735,     7,     7,   735,     8,  1213,  1214,  1002,   310,   311,
       7,     8,   529,   530,     7,   532,   533,     7,    31,    32,
     795,   355,   471,   540,     7,     7,   543,   351,   996,    26,
      27,    28,    29,    30,    31,    32,   353,  1001,   951,     3,
       4,   964,   352,   627,   316,   317,   318,   319,   565,   353,
      33,    34,    35,    36,    37,   353,   573,   641,   642,  1084,
     795,   314,   315,   894,   895,   364,   365,   999,  1000,   353,
    1002,   902,   353,   590,   591,   998,  1117,  1118,  1119,  1120,
       7,     8,   913,   914,   353,     7,  1117,  1118,   629,   920,
     921,   608,   353,   634,   635,   636,   353,   808,   639,    26,
      27,    28,    29,    30,    26,    27,    28,    29,    30,    31,
    1014,  1015,  1185,   358,   698,   850,   358,   892,   850,   849,
     850,   845,   846,   640,  1119,  1120,   643,   644,   645,  1042,
       3,     4,     5,   757,   845,   846,   847,   848,   358,   588,
     331,   332,   333,     3,     4,   337,  1114,     7,     8,   733,
     336,   881,     7,  1117,   403,   404,   358,   406,   407,   358,
     327,   328,   411,   358,  1205,  1160,    26,    27,    28,    29,
      30,    26,    27,    28,    29,    30,   358,   337,    38,    39,
      40,    41,   817,   818,   330,  1213,  1214,  1119,  1120,    49,
     350,   775,   358,   358,   778,   358,   334,   335,   819,   358,
     358,   336,   337,   338,   350,   358,   350,   358,   392,   358,
       7,   795,   350,     8,   327,   328,   336,   337,   338,   351,
     804,     6,   350,     6,   337,   371,   350,     6,  1160,   339,
     350,   357,   352,   817,   818,  1158,   350,   821,   822,   374,
     339,   366,  1155,  1156,   351,   351,   336,   337,   338,   369,
     358,   340,   836,   964,   374,   340,   376,   340,   842,   340,
     350,   996,   340,   358,   996,   997,   996,  1098,   365,   365,
     994,   358,   856,   857,   858,   351,   860,   861,   862,   863,
     864,   865,   351,   994,   995,   351,   351,   998,   351,   873,
     874,   351,   995,   351,  1024,  1025,   358,   351,   345,   346,
     347,   348,   349,   350,   352,   336,   337,   338,   492,   336,
     337,   338,   896,   897,   358,   351,  1048,  1047,   353,   903,
     352,   352,   351,   336,   337,   338,   336,   337,   338,   352,
     336,   337,   338,   354,   351,   852,   877,   878,   338,   336,
     337,   338,   351,   361,   351,   369,  1076,  1077,   351,   351,
     366,  1158,   366,   336,   337,   338,   369,   336,   370,   370,
    1191,   374,   336,   880,   351,   882,   367,   951,     6,   953,
     369,   369,   369,   358,   358,   351,  1108,   374,   358,  1114,
       6,   965,  1114,   351,  1114,   351,   656,   358,   972,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   982,   351,
     367,   351,   986,   365,   367,  1135,  1136,  1139,   367,   336,
     337,   338,  1144,   367,   336,   337,   338,   361,   362,   367,
     351,   367,  1006,   351,   368,   369,   367,   944,   367,   373,
     374,   375,   376,    33,    34,    35,    36,    37,   622,  1023,
     710,   320,   321,   322,   323,   324,   325,  1158,   365,   365,
     365,  1183,   374,   352,  1186,  1187,  1188,   351,  1042,   976,
    1192,  1193,  1194,  1195,  1196,   735,  1198,   351,     3,     4,
     351,   351,     7,     8,   744,   351,   336,   337,   338,   351,
       7,   336,   337,   338,   351,   353,   351,  1217,  1218,   433,
     350,   330,   352,   437,   358,   358,    31,    32,   351,  1016,
     358,   358,   358,    38,    39,    40,    41,   358,   778,  1026,
     358,   358,   358,   372,    49,  1099,   376,    50,    51,    52,
      53,    54,    55,    56,    57,   795,  1258,   351,  1112,   354,
     351,   354,   338,  1050,   351,   351,   351,   807,   351,   809,
     810,   351,  1126,   370,   814,    26,    27,    28,    29,    30,
     358,   370,  1069,  1070,  1071,   366,   361,   366,  1075,   358,
     341,  1078,   336,  1147,   336,   353,   370,   353,   375,   353,
     336,  1155,  1156,   375,  1158,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,  1171,   353,  1173,
    1174,  1175,  1176,   336,   353,   366,   358,   358,   358,   351,
       3,     4,     6,   367,     7,     8,   364,   364,   358,   478,
     479,   367,   481,   482,   483,  1132,   485,   486,   487,   488,
    1137,   368,   892,   367,   351,   367,   367,   897,    31,    32,
     368,   368,  1216,   367,   353,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,   368,   368,  1233,
    1234,   353,   353,   351,  1238,   351,   351,   351,   351,   351,
     351,  1245,   351,   351,   367,   351,   353,   366,   358,   538,
     375,  1255,  1256,   542,   358,   358,  1260,   358,   358,   358,
     358,   353,  1266,   953,   354,   351,   351,   351,   872,   351,
     351,   368,   368,   963,  1278,   368,   351,   967,   968,   368,
     351,   971,   972,     3,     4,   351,   328,     7,     8,   979,
    1294,   351,   375,   370,   366,   985,   375,   375,   366,   366,
     369,   358,   358,   368,   366,   368,    26,    27,    28,    29,
      30,    31,    32,     3,     4,   351,  1006,     7,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
     351,     3,     4,   351,   351,   351,    26,    27,    28,    29,
      30,    31,    32,   367,  1034,  1035,   351,   351,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
     351,   364,   351,   351,   351,   366,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,   368,   329,
     351,   336,   337,   338,   367,   367,   351,   351,   351,   368,
     953,   351,   367,   351,   368,   350,   368,   352,   365,   368,
     366,     0,   351,   351,   337,   351,  1096,     6,   351,  1099,
     351,   351,  1102,  1103,   369,   351,  1020,  1107,   337,   374,
     351,   376,  1112,    22,    23,    24,    25,   351,   367,   351,
     351,     6,   367,   351,   351,   351,  1126,   351,   353,   351,
     351,   351,   351,  1006,     6,   368,   351,   351,   368,   351,
    1140,    50,    51,    52,    53,    54,    55,    56,    57,   366,
      22,    23,    24,    25,   370,   368,   354,   351,   365,   352,
     351,   367,   367,   351,   368,   351,   351,   368,   365,   365,
    1170,  1171,   351,  1173,  1174,  1175,  1176,   351,    50,    51,
      52,    53,    54,    55,    56,    57,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,   368,
     351,   351,   351,   336,   337,   338,   365,   351,   351,   351,
     368,   368,     6,   351,   351,   351,   351,   350,     6,   352,
     351,   351,   354,   351,   351,   351,  1099,    18,    67,   354,
     631,  1231,    69,  1233,  1234,  1235,   369,  1237,  1238,  1112,
     624,   374,   855,   376,   642,   557,   890,   855,   964,   390,
     569,   734,  1252,  1126,   457,  1255,  1256,   836,    -1,    -1,
     589,  1261,  1262,    -1,    -1,    -1,  1266,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1274,  1275,  1276,    -1,    -1,  1279,
    1280,   316,    -1,   318,  1284,    -1,    -1,    -1,  1288,    -1,
      -1,   326,    -1,  1293,   329,    -1,   331,   332,  1171,    -1,
    1173,  1174,  1175,  1176,   339,    -1,   336,   337,   338,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     350,    -1,   352,    -1,   359,   360,   361,   362,   363,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   336,   337,   338,   369,
      -1,   316,   371,   318,   374,    -1,   376,    -1,    -1,    -1,
     350,   326,   352,    -1,   329,    -1,   331,   332,    -1,    -1,
    1233,  1234,    -1,    -1,   339,  1238,    -1,    -1,   350,   369,
     352,    -1,    -1,    -1,   374,    -1,   376,    -1,    -1,    -1,
      -1,    -1,  1255,  1256,   359,   360,   361,   362,    -1,    -1,
     299,   300,    -1,  1266,   376,   424,   425,   426,   427,   428,
     429,   430,   431,   432,    -1,    -1,   435,   436,    -1,   438,
     439,   440,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,   300,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   595,   596,   597,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     609,   610,    -1,   612,   613,   614,   615,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   655,    -1,    -1,    -1,
     659,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   668,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   378,   379,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,   380,   381,   383,
     384,   388,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,     3,     4,     5,   350,   382,   352,   382,   352,
     352,   352,   382,   352,   352,   352,   382,   382,     6,    22,
      23,    24,    25,    50,    51,    52,    53,    54,    55,    56,
      57,   299,   300,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   544,   547,   548,   380,     3,   351,     8,   389,
       7,     7,     8,     8,     7,     7,     7,   355,     7,   405,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   412,   427,   429,   432,   434,   436,   438,   440,   442,
     443,   444,   445,   447,   450,   451,   452,   453,   454,   455,
     456,   457,   458,   459,   468,   479,   488,   494,   496,   498,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   512,   513,   517,   518,   519,   520,   521,   522,   524,
     526,   530,   532,   533,   536,   539,   542,   407,   351,   545,
     546,   382,   353,   352,   387,   353,   353,   353,   353,   353,
     353,   353,   413,   414,   415,   358,   417,   418,   419,   420,
     421,   422,   423,   358,   424,   425,   358,   337,   336,   358,
     358,   358,   358,   358,   480,   481,   482,   484,   483,   489,
     490,   492,   491,   495,   499,   485,   493,   497,   486,   527,
     528,   531,   537,   538,   543,     7,    31,    33,    34,    35,
      36,    37,   336,   337,   338,   374,   554,   556,   557,   558,
     572,   558,   358,   558,   558,   558,   558,   358,   448,   558,
     358,   460,   461,   358,   461,   461,   358,   469,   469,   469,
     358,   471,   469,   469,   471,   469,   469,   469,   469,   358,
       7,   545,   351,   382,     8,   382,   385,   386,     6,     6,
       6,   338,   356,   409,   409,   409,     3,     4,   350,   578,
     409,   409,   357,   411,   411,   411,   409,   411,   339,   411,
     411,   339,   351,   351,   340,   340,   340,   340,   340,   471,
     471,   471,   471,   471,   471,   471,   471,   471,   469,   366,
     471,   471,   469,   471,   471,   471,   358,   358,   534,   535,
     535,   358,   365,   365,   557,   554,   351,   351,   351,   320,
     321,   322,   323,   324,   325,   446,   351,   351,   351,   351,
     312,   313,   358,   449,   351,   316,   318,   326,   329,   331,
     332,   339,   359,   360,   361,   362,   461,   558,   363,   352,
     464,   464,   310,   311,   358,   470,   470,   470,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   580,   470,   470,
     470,   558,   470,   470,   470,   470,   330,   371,   475,   523,
     578,   382,   351,   353,   351,   352,   352,   354,   338,   351,
     351,   351,     3,     4,   416,   351,   351,     6,   578,   426,
     430,   433,   435,   437,   439,   441,   558,   558,   369,   558,
     558,   366,   366,   370,   361,   470,   367,   558,   370,   470,
     558,   369,   369,   345,   346,   347,   348,   349,   529,   578,
     366,   370,   373,   374,   535,   342,   343,   344,   541,   336,
     336,     7,     8,    26,    27,    28,    29,    30,    31,    32,
      38,    39,    40,    41,    49,   336,   337,   338,   352,   369,
     374,   376,   428,   549,   550,   551,   552,   553,   555,   559,
     560,   561,   563,   564,   565,   571,   573,   574,   575,   578,
     428,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,   352,   376,   560,   565,   566,   576,   577,
     578,   558,   566,   565,   560,   561,   567,   574,   576,   561,
     562,   571,   314,   315,   558,   566,   351,   461,   580,   558,
     558,   316,   317,   318,   319,   471,   471,   471,   558,   471,
     471,   471,   471,   471,   471,   358,   358,   358,   351,   382,
     386,     6,     6,   578,   411,   338,   356,   410,   410,   411,
     411,   411,   411,   558,   431,   560,   565,   575,   431,   558,
     558,   558,   351,   351,   367,   351,   351,   367,   367,   367,
     367,   471,   553,   351,   367,   471,   351,   367,   367,   471,
     358,   350,   364,   568,   569,   569,   365,   365,     5,   334,
     335,   350,   578,   579,   365,   365,   352,   560,   553,   555,
     574,   578,   352,   577,   576,   351,   351,   351,   351,   351,
     351,   549,   464,   353,   351,   351,   358,   358,   358,   351,
     358,   358,   358,   358,   358,   358,   475,   330,   372,   516,
     553,   578,   351,   354,   354,   351,   338,   351,   351,   575,
     351,   351,   351,   366,   366,   337,   525,   578,   370,   361,
     553,   478,   560,   564,   553,   553,   358,   364,   472,   473,
     569,   370,   553,   358,   370,   525,   525,   554,   341,   578,
     578,   375,   375,   336,   336,   353,   353,     5,   353,   353,
     336,   336,   578,   579,   353,   578,   566,   566,   564,   564,
     561,   567,   558,   549,   327,   328,   462,   463,   466,   549,
     475,   475,   475,   366,   475,   475,   475,   475,   475,   475,
     358,   358,   358,   351,   382,   578,   578,     6,   411,   411,
     558,   561,   558,   367,   367,   364,   368,   367,   367,   472,
     368,   364,   364,   474,   569,   474,   475,   553,   368,   367,
     474,   475,   367,   368,   368,   351,   358,   569,   569,   569,
     569,   353,   353,   353,   351,   351,   351,   351,   351,   351,
     351,   351,   351,   358,   358,   358,   367,   558,   511,   358,
     358,   358,   358,   331,   332,   333,   515,   475,   515,   516,
     351,   353,   353,   354,   351,   351,   351,   553,   478,   578,
     351,   553,   553,   368,   351,   352,   477,   553,   553,   368,
     368,   558,   351,   553,   368,   366,   578,   351,   351,   553,
     578,   375,   375,   375,   375,   566,   565,   567,   576,   564,
     549,   462,   463,   466,   467,   549,   463,   467,   549,   370,
     366,   366,   516,   351,   366,   515,   515,   515,   515,   358,
     514,   514,   514,   558,   358,   369,   382,   578,   561,   561,
     558,   473,   368,   366,   473,   473,   351,   553,   553,   364,
     365,   476,   351,   351,   351,   475,   473,   351,   367,   368,
     561,   576,   351,   558,   351,   568,   570,   351,   351,   351,
     351,   558,   558,   558,   368,   366,   367,   558,   561,   561,
     558,   329,   515,   367,   351,   351,   351,   351,   368,   351,
     367,   368,   368,   553,   351,   569,   516,   365,   553,   553,
     366,   368,   553,   576,   487,   351,   351,   516,   351,   567,
     351,   465,   551,   465,   465,   467,   549,   467,   351,   351,
     351,   367,   516,   351,   351,   351,   351,   558,   337,     6,
     561,   561,   558,   351,   576,   553,   351,   351,   351,   576,
     353,   578,   351,   351,   367,   351,   351,   368,   351,   475,
     475,   540,   564,   575,   467,   351,   370,   366,   553,   516,
     368,   516,   516,   516,   516,   368,   354,   351,   351,   576,
     473,   576,   576,   576,   365,   569,   576,   576,   576,   576,
     576,   351,   576,   367,   367,   351,   368,   351,   351,   570,
     570,   578,   561,   561,   368,   365,   365,   368,   553,   516,
     516,   553,   351,   553,   516,   351,   351,   351,   351,   578,
     365,   351,   351,   368,   368,   553,   351,   516,   516,     6,
     576,   578,   553,   553,   351,   351,   351,   516,   354,   351,
     351,   553,   553,   553,   351,   578,   553,   553,   351,   553,
     351,   553,     6,   351,   354,   553,   578
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   377,   379,   378,   380,   380,   381,   381,   381,   381,
     381,   381,   381,   381,   381,   381,   381,   381,   381,   382,
     382,   382,   382,   383,   384,   385,   386,   386,   386,   387,
     387,   389,   388,   390,   391,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   404,
     404,   404,   404,   404,   404,   404,   405,   405,   406,   406,
     407,   407,   407,   407,   407,   407,   407,   407,   407,   407,
     407,   407,   407,   407,   407,   408,   409,   409,   410,   410,
     411,   411,   412,   413,   412,   414,   412,   415,   412,   416,
     412,   417,   412,   418,   412,   419,   412,   420,   412,   421,
     412,   412,   422,   412,   412,   412,   412,   412,   412,   412,
     423,   412,   412,   412,   412,   412,   424,   412,   412,   425,
     412,   412,   412,   412,   412,   426,   412,   427,   427,   428,
     428,   430,   429,   431,   431,   431,   433,   432,   435,   434,
     437,   436,   439,   438,   441,   440,   442,   442,   442,   442,
     442,   442,   442,   442,   443,   443,   443,   443,   443,   443,
     443,   443,   443,   443,   443,   443,   443,   443,   444,   444,
     444,   444,   444,   444,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   445,   445,   445,   445,   445,   445,   445,   445,   445,
     445,   446,   446,   446,   446,   446,   446,   447,   447,   447,
     448,   448,   449,   449,   450,   450,   450,   450,   450,   450,
     450,   450,   450,   450,   450,   450,   450,   450,   450,   450,
     451,   451,   451,   451,   451,   452,   452,   453,   453,   454,
     454,   454,   454,   455,   455,   455,   455,   455,   455,   455,
     455,   455,   455,   456,   457,   457,   458,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   460,   460,   460,
     460,   460,   460,   460,   460,   460,   460,   460,   461,   461,
     462,   463,   464,   465,   466,   466,   466,   466,   467,   467,
     467,   467,   468,   468,   468,   468,   468,   468,   468,   468,
     468,   469,   469,   470,   470,   470,   470,   471,   472,   473,
     473,   474,   474,   475,   476,   476,   477,   477,   478,   480,
     479,   481,   479,   482,   479,   483,   479,   484,   479,   485,
     479,   486,   487,   479,   489,   488,   490,   488,   491,   488,
     492,   488,   493,   488,   495,   494,   497,   496,   499,   498,
     500,   500,   500,   500,   500,   500,   500,   500,   500,   500,
     500,   501,   501,   501,   501,   501,   501,   501,   501,   501,
     501,   501,   502,   502,   502,   502,   502,   502,   502,   502,
     502,   502,   502,   503,   504,   505,   506,   506,   506,   507,
     508,   509,   510,   510,   511,   510,   512,   512,   512,   513,
     514,   514,   515,   515,   515,   516,   516,   517,   518,   518,
     518,   518,   518,   518,   518,   518,   518,   518,   518,   519,
     520,   521,   521,   521,   521,   522,   523,   523,   523,   524,
     525,   525,   525,   527,   526,   528,   526,   529,   529,   529,
     529,   529,   529,   531,   530,   532,   532,   532,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   533,   533,
     533,   534,   534,   534,   534,   535,   535,   537,   536,   538,
     536,   539,   539,   539,   540,   540,   541,   541,   541,   542,
     542,   542,   542,   542,   542,   542,   543,   542,   544,   545,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   553,
     553,   553,   554,   554,   554,   554,   555,   556,   556,   556,
     556,   556,   557,   557,   558,   558,   559,   559,   559,   559,
     559,   560,   560,   561,   561,   562,   562,   563,   563,   564,
     564,   565,   565,   565,   566,   566,   566,   567,   567,   567,
     568,   568,   569,   569,   570,   571,   571,   572,   572,   573,
     573,   574,   574,   575,   575,   575,   575,   575,   575,   575,
     575,   575,   575,   575,   575,   576,   576,   576,   576,   576,
     577,   577,   577,   577,   577,   577,   577,   577,   577,   577,
     577,   577,   578,   578,   578,   578,   579,   579,   580,   580,
     580,   580,   580,   580,   580,   580,   580
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     6,    11,     1,     1,     3,     0,     3,
       0,     0,     5,     4,     4,     4,     4,     2,     2,     2,
       1,    10,    10,    23,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     2,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     1,     2,     1,
       2,     2,     1,     0,     5,     0,     7,     0,     7,     0,
       5,     0,     5,     0,     5,     0,     3,     0,     3,     0,
       3,     1,     0,     3,     1,     1,     1,     1,     1,     1,
       0,     3,     1,     1,     1,     1,     0,     3,     1,     0,
       3,     1,     1,     1,     1,     0,     5,     3,     3,     1,
       1,     0,     5,     1,     1,     2,     0,     5,     0,     5,
       0,    11,     0,    13,     0,    13,     1,     1,     1,     1,
       1,     1,     4,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     8,     6,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     8,
       8,     8,    10,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     0,     2,
       1,     1,     3,     1,     1,     3,     1,     1,     1,     3,
       3,     3,     5,    10,     8,     6,     4,    10,     8,    11,
       1,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       2,     1,     2,     1,     7,     2,     7,     2,     3,     0,
      12,     0,    11,     0,    15,     0,    12,     0,    12,     0,
      12,     0,     0,    12,     0,    12,     0,    11,     0,    12,
       0,    12,     0,    12,     0,    17,     0,    17,     0,     9,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,    20,    13,    16,     1,     1,     1,     1,
       1,     1,     9,    16,     0,    17,     1,     1,     1,     3,
       0,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,    11,    13,    14,    14,     1,     6,     8,     9,     7,
       1,     1,     3,     0,    11,     0,    11,     1,     1,     1,
       1,     1,     1,     0,    10,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     0,     2,     0,     3,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,    11,     1,     1,
       2,     2,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     2,     1,
       1,     1,     1,     2,     1,     2,     1,     1,     1,     1,
       0,     2,     1,     2,     1,     5,     5,     5,     5,     5,
       5,     1,     1,     1,     3,     3,     4,     4,     3,     3,
       1,     1,     1,     1,     1,     1,     3,     1,     4,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     2,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 780 "../src/freedreno/ir3/ir3_parser.y"
                   { new_shader(); }
#line 3355 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 19: /* const_val: T_FLOAT  */
#line 799 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = fui((yyvsp[0].flt)); }
#line 3361 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 20: /* const_val: T_INT  */
#line 800 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].num);      }
#line 3367 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 21: /* const_val: '-' T_INT  */
#line 801 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = -(yyvsp[0].num);     }
#line 3373 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 22: /* const_val: T_HEX  */
#line 802 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].unum);      }
#line 3379 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 23: /* localsize_header: T_A_LOCALSIZE const_val ',' const_val ',' const_val  */
#line 804 "../src/freedreno/ir3/ir3_parser.y"
                                                                       {
                       variant->local_size[0] = (yyvsp[-4].unum);
                       variant->local_size[1] = (yyvsp[-2].unum);
                       variant->local_size[2] = (yyvsp[0].unum);
}
#line 3389 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 24: /* const_header: T_A_CONST '(' T_CONSTANT ')' const_val ',' const_val ',' const_val ',' const_val  */
#line 810 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                    {
                       add_const((yyvsp[-8].num), (yyvsp[-6].unum), (yyvsp[-4].unum), (yyvsp[-2].unum), (yyvsp[0].unum));
}
#line 3397 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 25: /* buf_header_init_val: const_val  */
#line 814 "../src/freedreno/ir3/ir3_parser.y"
                                { add_buf_init_val((yyvsp[0].unum)); }
#line 3403 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 29: /* buf_header_addr_reg: '(' T_CONSTANT ')'  */
#line 820 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;

                       info->buf_addr_regs[info->num_bufs - 1] = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3416 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 31: /* $@2: %empty  */
#line 830 "../src/freedreno/ir3/ir3_parser.y"
                                     {
                       int idx = info->num_bufs++;
                       assert(idx < MAX_BUFS);
                       info->buf_sizes[idx] = (yyvsp[0].unum);
}
#line 3426 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 33: /* invocationid_header: T_A_INVOCATIONID '(' T_REGISTER ')'  */
#line 836 "../src/freedreno/ir3/ir3_parser.y"
                                                         {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       add_sysval(reg, 0x7, SYSTEM_VALUE_LOCAL_INVOCATION_ID);
}
#line 3436 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 34: /* wgid_header: T_A_WGID '(' T_REGISTER ')'  */
#line 842 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen >= 5);
                       assert(reg >= regid(48, 0)); /* must be a high reg */
                       add_sysval(reg, 0x7, SYSTEM_VALUE_WORKGROUP_ID);
}
#line 3448 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 35: /* wgid_header: T_A_WGID '(' T_CONSTANT ')'  */
#line 849 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen < 5);
                       info->wgid = reg;
}
#line 3459 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 36: /* numwg_header: T_A_NUMWG '(' T_CONSTANT ')'  */
#line 856 "../src/freedreno/ir3/ir3_parser.y"
                                                {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       info->numwg = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       if (variant->compiler->gen >= 5)
                          add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3472 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 37: /* branchstack_header: T_A_BRANCHSTACK const_val  */
#line 865 "../src/freedreno/ir3/ir3_parser.y"
                                              { variant->branchstack = (yyvsp[0].unum); }
#line 3478 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 38: /* pvtmem_header: T_A_PVTMEM const_val  */
#line 867 "../src/freedreno/ir3/ir3_parser.y"
                                    { variant->pvtmem_size = (yyvsp[0].unum); }
#line 3484 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 39: /* localmem_header: T_A_LOCALMEM const_val  */
#line 869 "../src/freedreno/ir3/ir3_parser.y"
                                        { variant->shared_size = (yyvsp[0].unum); }
#line 3490 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 40: /* earlypreamble_header: T_A_EARLYPREAMBLE  */
#line 871 "../src/freedreno/ir3/ir3_parser.y"
                                        { variant->early_preamble = 1; }
#line 3496 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 41: /* in_header: T_A_IN '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 874 "../src/freedreno/ir3/ir3_parser.y"
                                                                                           { }
#line 3502 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 42: /* out_header: T_A_OUT '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 876 "../src/freedreno/ir3/ir3_parser.y"
                                                                                            { }
#line 3508 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 43: /* tex_header: T_A_TEX '(' T_REGISTER ')' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer  */
#line 883 "../src/freedreno/ir3/ir3_parser.y"
                                                              { }
#line 3514 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 44: /* fullnop_start_section: T_A_FULLNOPSTART  */
#line 885 "../src/freedreno/ir3/ir3_parser.y"
                                        { is_in_fullnop_section = true; }
#line 3520 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 45: /* fullnop_end_section: T_A_FULLNOPEND  */
#line 886 "../src/freedreno/ir3/ir3_parser.y"
                                    { is_in_fullnop_section = false; }
#line 3526 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 46: /* fullsync_start_section: T_A_FULLSYNCSTART  */
#line 887 "../src/freedreno/ir3/ir3_parser.y"
                                          { is_in_fullsync_section = true; }
#line 3532 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 47: /* fullsync_end_section: T_A_FULLSYNCEND  */
#line 888 "../src/freedreno/ir3/ir3_parser.y"
                                      { is_in_fullsync_section = false; }
#line 3538 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 48: /* iflag: T_SY  */
#line 890 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SY; }
#line 3544 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 49: /* iflag: T_SS  */
#line 891 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SS; }
#line 3550 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 50: /* iflag: T_JP  */
#line 892 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_JP; }
#line 3556 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 51: /* iflag: T_EQ_FLAG  */
#line 893 "../src/freedreno/ir3/ir3_parser.y"
                             { iflags.flags |= IR3_INSTR_EQ; }
#line 3562 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 52: /* iflag: T_SAT  */
#line 894 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SAT; }
#line 3568 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 53: /* iflag: T_RPT  */
#line 895 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.repeat = (yyvsp[0].num); }
#line 3574 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 54: /* iflag: T_UL  */
#line 896 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_UL; }
#line 3580 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 55: /* iflag: T_NOP  */
#line 897 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.nop = (yyvsp[0].tok); }
#line 3586 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 65: /* instr: iflags cat5_instr  */
#line 910 "../src/freedreno/ir3/ir3_parser.y"
                                     { fixup_cat5_s2en(); }
#line 3592 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 75: /* label: T_IDENTIFIER ':'  */
#line 921 "../src/freedreno/ir3/ir3_parser.y"
                                    { new_label((yyvsp[-1].str)); }
#line 3598 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 76: /* cat0_src1: '!' T_P0  */
#line 923 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv1 = true; (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 3604 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 77: /* cat0_src1: T_P0  */
#line 924 "../src/freedreno/ir3/ir3_parser.y"
                                   { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 3610 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 78: /* cat0_src2: '!' T_P0  */
#line 926 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv2 = true; (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 3616 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 79: /* cat0_src2: T_P0  */
#line 927 "../src/freedreno/ir3/ir3_parser.y"
                                   { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 3622 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 80: /* cat0_immed: '#' integer  */
#line 929 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.immed = (yyvsp[0].num); }
#line 3628 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 81: /* cat0_immed: '#' T_IDENTIFIER  */
#line 930 "../src/freedreno/ir3/ir3_parser.y"
                                    { ralloc_steal(instr, (void *)(yyvsp[0].str)); instr->cat0.target_label = (yyvsp[0].str); }
#line 3634 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 82: /* cat0_instr: T_OP_NOP  */
#line 932 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_NOP); }
#line 3640 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 83: /* $@3: %empty  */
#line 933 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BR);   }
#line 3646 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 85: /* $@4: %empty  */
#line 934 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BRAO); }
#line 3652 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 87: /* $@5: %empty  */
#line 935 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BRAA); }
#line 3658 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 89: /* $@6: %empty  */
#line 936 "../src/freedreno/ir3/ir3_parser.y"
                                         { new_instr(OPC_BRAC)->cat0.idx = (yyvsp[0].num); }
#line 3664 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 91: /* $@7: %empty  */
#line 937 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BANY); }
#line 3670 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 93: /* $@8: %empty  */
#line 938 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BALL); }
#line 3676 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 95: /* $@9: %empty  */
#line 939 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BRAX); }
#line 3682 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 97: /* $@10: %empty  */
#line 940 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_JUMP); }
#line 3688 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 99: /* $@11: %empty  */
#line 941 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CALL); }
#line 3694 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 101: /* cat0_instr: T_OP_RET  */
#line 942 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_RET); }
#line 3700 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 102: /* $@12: %empty  */
#line 943 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_KILL); }
#line 3706 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 104: /* cat0_instr: T_OP_END  */
#line 944 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_END); }
#line 3712 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 105: /* cat0_instr: T_OP_EMIT  */
#line 945 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_EMIT); }
#line 3718 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 106: /* cat0_instr: T_OP_CUT  */
#line 946 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CUT); }
#line 3724 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 107: /* cat0_instr: T_OP_CHMASK  */
#line 947 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHMASK); }
#line 3730 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 108: /* cat0_instr: T_OP_CHSH  */
#line 948 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHSH); }
#line 3736 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 109: /* cat0_instr: T_OP_FLOW_REV  */
#line 949 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_FLOW_REV); }
#line 3742 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 110: /* $@13: %empty  */
#line 950 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BKT); }
#line 3748 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 112: /* cat0_instr: T_OP_STKS  */
#line 951 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKS); }
#line 3754 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 113: /* cat0_instr: T_OP_STKR  */
#line 952 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKR); }
#line 3760 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 114: /* cat0_instr: T_OP_XSET  */
#line 953 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XSET); }
#line 3766 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 115: /* cat0_instr: T_OP_XCLR  */
#line 954 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XCLR); }
#line 3772 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 116: /* $@14: %empty  */
#line 955 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETONE); }
#line 3778 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 118: /* cat0_instr: T_OP_DBG  */
#line 956 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_DBG); }
#line 3784 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 119: /* $@15: %empty  */
#line 957 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPS); }
#line 3790 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 121: /* cat0_instr: T_OP_SHPE  */
#line 958 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPE); }
#line 3796 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 122: /* cat0_instr: T_OP_PREDT  */
#line 959 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDT); }
#line 3802 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 123: /* cat0_instr: T_OP_PREDF  */
#line 960 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDF); }
#line 3808 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 124: /* cat0_instr: T_OP_PREDE  */
#line 961 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDE); }
#line 3814 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 125: /* $@16: %empty  */
#line 962 "../src/freedreno/ir3/ir3_parser.y"
                                        { new_instr(OPC_GETLAST); }
#line 3820 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 127: /* cat1_opc: T_OP_MOV '.' T_CAT1_TYPE_TYPE  */
#line 964 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3828 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 128: /* cat1_opc: T_OP_COV '.' T_CAT1_TYPE_TYPE  */
#line 967 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3836 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 131: /* $@17: %empty  */
#line 974 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOVMSK);
                       instr->cat1.src_type = TYPE_U32;
                       instr->cat1.dst_type = TYPE_U32;
                   }
#line 3846 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 132: /* cat1_movmsk: T_OP_MOVMSK '.' T_W $@17 dst_reg  */
#line 978 "../src/freedreno/ir3/ir3_parser.y"
                             {
                       if (((yyvsp[-2].num) % 32) != 0)
                          yyerror("w# must be multiple of 32");
                       if ((yyvsp[-2].num) < 32)
                          yyerror("w# must be at least 32");

                       int num = (yyvsp[-2].num) / 32;

                       instr->repeat = num - 1;
                       instr->dsts[0]->wrmask = (1 << num) - 1;
                   }
#line 3862 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 136: /* $@18: %empty  */
#line 994 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_U16;
                       instr->cat1.dst_type = TYPE_U16;
                       new_dst((61 << 3) + 2, IR3_REG_HALF);
                   }
#line 3873 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 138: /* $@19: %empty  */
#line 1001 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_S16;
                       instr->cat1.dst_type = TYPE_S16;
                       new_dst((61 << 3), IR3_REG_HALF);
                   }
#line 3884 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 140: /* $@20: %empty  */
#line 1008 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SWZ), (yyvsp[0].str)); }
#line 3890 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 142: /* $@21: %empty  */
#line 1010 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_GAT), (yyvsp[0].str)); }
#line 3896 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 144: /* $@22: %empty  */
#line 1012 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SCT), (yyvsp[0].str)); }
#line 3902 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 154: /* cat2_opc_1src: T_OP_ABSNEG_F  */
#line 1024 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_F); }
#line 3908 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 155: /* cat2_opc_1src: T_OP_ABSNEG_S  */
#line 1025 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_S); }
#line 3914 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 156: /* cat2_opc_1src: T_OP_CLZ_B  */
#line 1026 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_B); }
#line 3920 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 157: /* cat2_opc_1src: T_OP_CLZ_S  */
#line 1027 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_S); }
#line 3926 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 158: /* cat2_opc_1src: T_OP_SIGN_F  */
#line 1028 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIGN_F); }
#line 3932 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 159: /* cat2_opc_1src: T_OP_FLOOR_F  */
#line 1029 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLOOR_F); }
#line 3938 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 160: /* cat2_opc_1src: T_OP_CEIL_F  */
#line 1030 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CEIL_F); }
#line 3944 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 161: /* cat2_opc_1src: T_OP_RNDNE_F  */
#line 1031 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDNE_F); }
#line 3950 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 162: /* cat2_opc_1src: T_OP_RNDAZ_F  */
#line 1032 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDAZ_F); }
#line 3956 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 163: /* cat2_opc_1src: T_OP_TRUNC_F  */
#line 1033 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_TRUNC_F); }
#line 3962 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 164: /* cat2_opc_1src: T_OP_NOT_B  */
#line 1034 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_NOT_B); }
#line 3968 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 165: /* cat2_opc_1src: T_OP_BFREV_B  */
#line 1035 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BFREV_B); }
#line 3974 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 166: /* cat2_opc_1src: T_OP_SETRM  */
#line 1036 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SETRM); }
#line 3980 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 167: /* cat2_opc_1src: T_OP_CBITS_B  */
#line 1037 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CBITS_B); }
#line 3986 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 168: /* cat2_opc_2src_cnd: T_OP_CMPS_F  */
#line 1039 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_F); }
#line 3992 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 169: /* cat2_opc_2src_cnd: T_OP_CMPS_U  */
#line 1040 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_U); }
#line 3998 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 170: /* cat2_opc_2src_cnd: T_OP_CMPS_S  */
#line 1041 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_S); }
#line 4004 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 171: /* cat2_opc_2src_cnd: T_OP_CMPV_F  */
#line 1042 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_F); }
#line 4010 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 172: /* cat2_opc_2src_cnd: T_OP_CMPV_U  */
#line 1043 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_U); }
#line 4016 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 173: /* cat2_opc_2src_cnd: T_OP_CMPV_S  */
#line 1044 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_S); }
#line 4022 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 174: /* cat2_opc_2src: T_OP_ADD_F  */
#line 1046 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_F); }
#line 4028 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 175: /* cat2_opc_2src: T_OP_MIN_F  */
#line 1047 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_F); }
#line 4034 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 176: /* cat2_opc_2src: T_OP_MAX_F  */
#line 1048 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_F); }
#line 4040 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 177: /* cat2_opc_2src: T_OP_MUL_F  */
#line 1049 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_F); }
#line 4046 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 178: /* cat2_opc_2src: T_OP_ADD_U  */
#line 1050 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_U); }
#line 4052 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 179: /* cat2_opc_2src: T_OP_ADD_S  */
#line 1051 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_S); }
#line 4058 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 180: /* cat2_opc_2src: T_OP_SUB_U  */
#line 1052 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_U); }
#line 4064 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 181: /* cat2_opc_2src: T_OP_SUB_S  */
#line 1053 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_S); }
#line 4070 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 182: /* cat2_opc_2src: T_OP_MIN_U  */
#line 1054 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_U); }
#line 4076 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 183: /* cat2_opc_2src: T_OP_MIN_S  */
#line 1055 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_S); }
#line 4082 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 184: /* cat2_opc_2src: T_OP_MAX_U  */
#line 1056 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_U); }
#line 4088 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 185: /* cat2_opc_2src: T_OP_MAX_S  */
#line 1057 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_S); }
#line 4094 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 186: /* cat2_opc_2src: T_OP_AND_B  */
#line 1058 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_AND_B); }
#line 4100 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 187: /* cat2_opc_2src: T_OP_OR_B  */
#line 1059 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_OR_B); }
#line 4106 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 188: /* cat2_opc_2src: T_OP_XOR_B  */
#line 1060 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_XOR_B); }
#line 4112 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 189: /* cat2_opc_2src: T_OP_MUL_U24  */
#line 1061 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_U24); }
#line 4118 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 190: /* cat2_opc_2src: T_OP_MUL_S24  */
#line 1062 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_S24); }
#line 4124 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 191: /* cat2_opc_2src: T_OP_MULL_U  */
#line 1063 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MULL_U); }
#line 4130 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 192: /* cat2_opc_2src: T_OP_SHL_B  */
#line 1064 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHL_B); }
#line 4136 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 193: /* cat2_opc_2src: T_OP_SHR_B  */
#line 1065 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHR_B); }
#line 4142 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 194: /* cat2_opc_2src: T_OP_ASHR_B  */
#line 1066 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ASHR_B); }
#line 4148 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 195: /* cat2_opc_2src: T_OP_BARY_F  */
#line 1067 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BARY_F); }
#line 4154 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 196: /* cat2_opc_2src: T_OP_FLAT_B  */
#line 1068 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLAT_B); }
#line 4160 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 197: /* cat2_opc_2src: T_OP_MGEN_B  */
#line 1069 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MGEN_B); }
#line 4166 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 198: /* cat2_opc_2src: T_OP_GETBIT_B  */
#line 1070 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBIT_B); }
#line 4172 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 199: /* cat2_opc_2src: T_OP_SHB  */
#line 1071 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHB); }
#line 4178 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 200: /* cat2_opc_2src: T_OP_MSAD  */
#line 1072 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MSAD); }
#line 4184 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 201: /* cond: T_LT  */
#line 1074 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LT; }
#line 4190 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 202: /* cond: T_LE  */
#line 1075 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LE; }
#line 4196 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 203: /* cond: T_GT  */
#line 1076 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GT; }
#line 4202 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 204: /* cond: T_GE  */
#line 1077 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GE; }
#line 4208 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 205: /* cond: T_EQ  */
#line 1078 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_EQ; }
#line 4214 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 206: /* cond: T_NE  */
#line 1079 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_NE; }
#line 4220 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 210: /* cat3_dp_signedness: '.' T_MIXED  */
#line 1085 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_MIXED; }
#line 4226 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 211: /* cat3_dp_signedness: '.' T_UNSIGNED  */
#line 1086 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_UNSIGNED; }
#line 4232 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 212: /* cat3_dp_pack: '.' T_LOW  */
#line 1088 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_LOW; }
#line 4238 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 213: /* cat3_dp_pack: '.' T_HIGH  */
#line 1089 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_HIGH; }
#line 4244 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 214: /* cat3_opc: T_OP_MAD_U16  */
#line 1091 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U16); }
#line 4250 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 215: /* cat3_opc: T_OP_MADSH_U16  */
#line 1092 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_U16); }
#line 4256 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 216: /* cat3_opc: T_OP_MAD_S16  */
#line 1093 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S16); }
#line 4262 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 217: /* cat3_opc: T_OP_MADSH_M16  */
#line 1094 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_M16); }
#line 4268 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 218: /* cat3_opc: T_OP_MAD_U24  */
#line 1095 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U24); }
#line 4274 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 219: /* cat3_opc: T_OP_MAD_S24  */
#line 1096 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S24); }
#line 4280 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 220: /* cat3_opc: T_OP_MAD_F16  */
#line 1097 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F16); }
#line 4286 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 221: /* cat3_opc: T_OP_MAD_F32  */
#line 1098 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F32); }
#line 4292 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 222: /* cat3_opc: T_OP_SEL_B16  */
#line 1099 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B16); }
#line 4298 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 223: /* cat3_opc: T_OP_SEL_B32  */
#line 1100 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B32); }
#line 4304 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 224: /* cat3_opc: T_OP_SEL_S16  */
#line 1101 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S16); }
#line 4310 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 225: /* cat3_opc: T_OP_SEL_S32  */
#line 1102 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S32); }
#line 4316 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 226: /* cat3_opc: T_OP_SEL_F16  */
#line 1103 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F16); }
#line 4322 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 227: /* cat3_opc: T_OP_SEL_F32  */
#line 1104 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F32); }
#line 4328 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 228: /* cat3_opc: T_OP_SAD_S16  */
#line 1105 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S16); }
#line 4334 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 229: /* cat3_opc: T_OP_SAD_S32  */
#line 1106 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S32); }
#line 4340 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 230: /* cat3_imm_reg_opc: T_OP_SHRM  */
#line 1108 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRM); }
#line 4346 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 231: /* cat3_imm_reg_opc: T_OP_SHLM  */
#line 1109 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLM); }
#line 4352 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 232: /* cat3_imm_reg_opc: T_OP_SHRG  */
#line 1110 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRG); }
#line 4358 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 233: /* cat3_imm_reg_opc: T_OP_SHLG  */
#line 1111 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLG); }
#line 4364 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 234: /* cat3_imm_reg_opc: T_OP_ANDG  */
#line 1112 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ANDG); }
#line 4370 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 235: /* cat3_wmm: T_OP_WMM  */
#line 1114 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM); }
#line 4376 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 236: /* cat3_wmm: T_OP_WMM_ACCU  */
#line 1115 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM_ACCU); }
#line 4382 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 237: /* cat3_dp: T_OP_DP2ACC  */
#line 1117 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP2ACC); }
#line 4388 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 238: /* cat3_dp: T_OP_DP4ACC  */
#line 1118 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP4ACC); }
#line 4394 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 243: /* cat4_opc: T_OP_RCP  */
#line 1125 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RCP); }
#line 4400 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 244: /* cat4_opc: T_OP_RSQ  */
#line 1126 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RSQ); }
#line 4406 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 245: /* cat4_opc: T_OP_LOG2  */
#line 1127 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LOG2); }
#line 4412 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 246: /* cat4_opc: T_OP_EXP2  */
#line 1128 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_EXP2); }
#line 4418 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 247: /* cat4_opc: T_OP_SIN  */
#line 1129 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIN); }
#line 4424 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 248: /* cat4_opc: T_OP_COS  */
#line 1130 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_COS); }
#line 4430 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 249: /* cat4_opc: T_OP_SQRT  */
#line 1131 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SQRT); }
#line 4436 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 250: /* cat4_opc: T_OP_HRSQ  */
#line 1132 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HRSQ); }
#line 4442 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 251: /* cat4_opc: T_OP_HLOG2  */
#line 1133 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HLOG2); }
#line 4448 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 252: /* cat4_opc: T_OP_HEXP2  */
#line 1134 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HEXP2); }
#line 4454 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 254: /* cat5_opc_dsxypp: T_OP_DSXPP_1  */
#line 1138 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSXPP_1)->cat5.type = TYPE_F32; }
#line 4460 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 255: /* cat5_opc_dsxypp: T_OP_DSYPP_1  */
#line 1139 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSYPP_1)->cat5.type = TYPE_F32; }
#line 4466 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 256: /* cat5_opc_isam: T_OP_ISAM  */
#line 1141 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAM)->flags |= IR3_INSTR_INV_1D; }
#line 4472 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 257: /* cat5_opc: T_OP_ISAML  */
#line 1143 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAML); }
#line 4478 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 258: /* cat5_opc: T_OP_ISAMM  */
#line 1144 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAMM); }
#line 4484 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 259: /* cat5_opc: T_OP_SAM  */
#line 1145 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAM); }
#line 4490 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 260: /* cat5_opc: T_OP_SAMB  */
#line 1146 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMB); }
#line 4496 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 261: /* cat5_opc: T_OP_SAML  */
#line 1147 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAML); }
#line 4502 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 262: /* cat5_opc: T_OP_SAMGQ  */
#line 1148 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGQ); }
#line 4508 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 263: /* cat5_opc: T_OP_GETLOD  */
#line 1149 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETLOD); }
#line 4514 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 264: /* cat5_opc: T_OP_CONV  */
#line 1150 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONV); }
#line 4520 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 265: /* cat5_opc: T_OP_CONVM  */
#line 1151 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONVM); }
#line 4526 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 266: /* cat5_opc: T_OP_GETSIZE  */
#line 1152 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETSIZE); }
#line 4532 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 267: /* cat5_opc: T_OP_GETBUF  */
#line 1153 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBUF); }
#line 4538 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 268: /* cat5_opc: T_OP_GETPOS  */
#line 1154 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETPOS); }
#line 4544 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 269: /* cat5_opc: T_OP_GETINFO  */
#line 1155 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETINFO); }
#line 4550 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 270: /* cat5_opc: T_OP_DSX  */
#line 1156 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSX); }
#line 4556 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 271: /* cat5_opc: T_OP_DSY  */
#line 1157 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSY); }
#line 4562 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 272: /* cat5_opc: T_OP_GATHER4R  */
#line 1158 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4R); }
#line 4568 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 273: /* cat5_opc: T_OP_GATHER4G  */
#line 1159 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4G); }
#line 4574 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 274: /* cat5_opc: T_OP_GATHER4B  */
#line 1160 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4B); }
#line 4580 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 275: /* cat5_opc: T_OP_GATHER4A  */
#line 1161 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4A); }
#line 4586 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 276: /* cat5_opc: T_OP_SAMGP0  */
#line 1162 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP0); }
#line 4592 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 277: /* cat5_opc: T_OP_SAMGP1  */
#line 1163 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP1); }
#line 4598 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 278: /* cat5_opc: T_OP_SAMGP2  */
#line 1164 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP2); }
#line 4604 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 279: /* cat5_opc: T_OP_SAMGP3  */
#line 1165 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP3); }
#line 4610 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 280: /* cat5_opc: T_OP_RGETPOS  */
#line 1166 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETPOS); }
#line 4616 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 281: /* cat5_opc: T_OP_RGETINFO  */
#line 1167 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETINFO); }
#line 4622 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 282: /* cat5_opc: T_OP_BRCST_A  */
#line 1168 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BRCST_ACTIVE); }
#line 4628 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 283: /* cat5_opc: T_OP_QSHUFFLE_BRCST  */
#line 1169 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_BRCST); }
#line 4634 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 284: /* cat5_opc: T_OP_QSHUFFLE_H  */
#line 1170 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_HORIZ); }
#line 4640 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 285: /* cat5_opc: T_OP_QSHUFFLE_V  */
#line 1171 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_VERT); }
#line 4646 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 286: /* cat5_opc: T_OP_QSHUFFLE_DIAG  */
#line 1172 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_DIAG); }
#line 4652 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 287: /* cat5_flag: '.' T_3D  */
#line 1174 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_3D; }
#line 4658 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 288: /* cat5_flag: '.' 'a'  */
#line 1175 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A; }
#line 4664 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 289: /* cat5_flag: '.' 'o'  */
#line 1176 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_O; }
#line 4670 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 290: /* cat5_flag: '.' 'p'  */
#line 1177 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_P; }
#line 4676 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 291: /* cat5_flag: '.' 's'  */
#line 1178 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S; }
#line 4682 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 292: /* cat5_flag: '.' T_S2EN  */
#line 1179 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S2EN; }
#line 4688 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 293: /* cat5_flag: '.' T_1D  */
#line 1180 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags &= ~IR3_INSTR_INV_1D; }
#line 4694 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 294: /* cat5_flag: '.' T_UNIFORM  */
#line 1181 "../src/freedreno/ir3/ir3_parser.y"
                                  { }
#line 4700 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 295: /* cat5_flag: '.' T_NONUNIFORM  */
#line 1182 "../src/freedreno/ir3/ir3_parser.y"
                                     { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4706 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 296: /* cat5_flag: '.' T_BASE  */
#line 1183 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_B; instr->cat5.tex_base = (yyvsp[0].tok); }
#line 4712 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 297: /* cat5_flag: '.' T_W  */
#line 1184 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.cluster_size = (yyvsp[0].num); }
#line 4718 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 300: /* cat5_samp: T_SAMP  */
#line 1188 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.samp = (yyvsp[0].tok); }
#line 4724 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 301: /* cat5_tex: T_TEX  */
#line 1189 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.tex = (yyvsp[0].tok); }
#line 4730 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 302: /* cat5_type: '(' type ')'  */
#line 1190 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.type = (yyvsp[-1].type); }
#line 4736 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 303: /* cat5_a1: src_a1  */
#line 1191 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A1EN; }
#line 4742 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 319: /* cat5_instr: cat5_opc_isam '.' 'v' cat5_flags cat5_type dst_reg ',' src_gpr src_uoffset ',' cat5_samp_tex_all  */
#line 1210 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                    { instr->flags |= IR3_INSTR_V; }
#line 4748 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 320: /* cat5_instr: T_OP_TCINV  */
#line 1211 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_TCINV); }
#line 4754 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 321: /* cat6_typed: '.' T_UNTYPED  */
#line 1213 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 0; }
#line 4760 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 322: /* cat6_typed: '.' T_TYPED  */
#line 1214 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 1; }
#line 4766 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 323: /* cat6_dim: '.' T_1D  */
#line 1216 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 1; }
#line 4772 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 324: /* cat6_dim: '.' T_2D  */
#line 1217 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 2; }
#line 4778 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 325: /* cat6_dim: '.' T_3D  */
#line 1218 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 3; }
#line 4784 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 326: /* cat6_dim: '.' T_4D  */
#line 1219 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 4; }
#line 4790 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 327: /* cat6_type: '.' type  */
#line 1221 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.type = (yyvsp[0].type); }
#line 4796 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 328: /* cat6_imm_offset: offset  */
#line 1222 "../src/freedreno/ir3/ir3_parser.y"
                             { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4802 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 331: /* cat6_dst_offset: offset  */
#line 1225 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.dst_offset = (yyvsp[0].num); }
#line 4808 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 333: /* cat6_immed: integer  */
#line 1228 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.iim_val = (yyvsp[0].num); }
#line 4814 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 334: /* cat6_a6xx_global_address_pt3: '<' '<' integer offset '<' '<' integer  */
#line 1231 "../src/freedreno/ir3/ir3_parser.y"
                                                          {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num) - 2;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 4824 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 335: /* cat6_a6xx_global_address_pt3: '+' cat6_reg_or_immed  */
#line 1236 "../src/freedreno/ir3/ir3_parser.y"
                                         {
                        // Dummy src to smooth the difference between a6xx and a7xx
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                   }
#line 4833 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 336: /* cat6_a6xx_global_address_pt2: '(' src offset ')' '<' '<' integer  */
#line 1242 "../src/freedreno/ir3/ir3_parser.y"
                                                      {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num);
                   }
#line 4843 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 339: /* $@23: %empty  */
#line 1253 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG); }
#line 4849 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 341: /* $@24: %empty  */
#line 1254 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_A); }
#line 4855 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 343: /* $@25: %empty  */
#line 1255 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_K); }
#line 4861 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 345: /* $@26: %empty  */
#line 1256 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDP); }
#line 4867 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 347: /* $@27: %empty  */
#line 1257 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDL); }
#line 4873 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 349: /* $@28: %empty  */
#line 1258 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLW); }
#line 4879 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 351: /* $@29: %empty  */
#line 1259 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLV); }
#line 4885 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 352: /* $@30: %empty  */
#line 1259 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[-1].num);
                   }
#line 4893 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 354: /* $@31: %empty  */
#line 1263 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG); dummy_dst(); }
#line 4899 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 356: /* $@32: %empty  */
#line 1264 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG_A); dummy_dst(); }
#line 4905 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 358: /* $@33: %empty  */
#line 1265 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STP); dummy_dst(); }
#line 4911 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 360: /* $@34: %empty  */
#line 1266 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STL); dummy_dst(); }
#line 4917 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 362: /* $@35: %empty  */
#line 1267 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STLW); dummy_dst(); }
#line 4923 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 364: /* $@36: %empty  */
#line 1269 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDIB); }
#line 4929 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 366: /* $@37: %empty  */
#line 1270 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STIB); dummy_dst(); }
#line 4935 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 368: /* $@38: %empty  */
#line 1272 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_PREFETCH); new_dst(0,0); /* dummy dst */ }
#line 4941 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 370: /* cat6_atomic_opc: T_OP_ATOMIC_ADD  */
#line 1274 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_ADD); }
#line 4947 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 371: /* cat6_atomic_opc: T_OP_ATOMIC_SUB  */
#line 1275 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_SUB); }
#line 4953 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 372: /* cat6_atomic_opc: T_OP_ATOMIC_XCHG  */
#line 1276 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XCHG); }
#line 4959 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 373: /* cat6_atomic_opc: T_OP_ATOMIC_INC  */
#line 1277 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_INC); }
#line 4965 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 374: /* cat6_atomic_opc: T_OP_ATOMIC_DEC  */
#line 1278 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_DEC); }
#line 4971 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 375: /* cat6_atomic_opc: T_OP_ATOMIC_CMPXCHG  */
#line 1279 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_CMPXCHG); }
#line 4977 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 376: /* cat6_atomic_opc: T_OP_ATOMIC_MIN  */
#line 1280 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MIN); }
#line 4983 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 377: /* cat6_atomic_opc: T_OP_ATOMIC_MAX  */
#line 1281 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MAX); }
#line 4989 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 378: /* cat6_atomic_opc: T_OP_ATOMIC_AND  */
#line 1282 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_AND); }
#line 4995 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 379: /* cat6_atomic_opc: T_OP_ATOMIC_OR  */
#line 1283 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_OR); }
#line 5001 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 380: /* cat6_atomic_opc: T_OP_ATOMIC_XOR  */
#line 1284 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XOR); }
#line 5007 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 381: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_ADD  */
#line 1286 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_ADD); }
#line 5013 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 382: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_SUB  */
#line 1287 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_SUB); }
#line 5019 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 383: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XCHG  */
#line 1288 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XCHG); }
#line 5025 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 384: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_INC  */
#line 1289 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_INC); }
#line 5031 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 385: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_DEC  */
#line 1290 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_DEC); }
#line 5037 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 386: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_CMPXCHG  */
#line 1291 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_CMPXCHG); }
#line 5043 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 387: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MIN  */
#line 1292 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MIN); }
#line 5049 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 388: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MAX  */
#line 1293 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MAX); }
#line 5055 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 389: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_AND  */
#line 1294 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_AND); }
#line 5061 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 390: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_OR  */
#line 1295 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_OR); }
#line 5067 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 391: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XOR  */
#line 1296 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XOR); }
#line 5073 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 392: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_ADD  */
#line 1298 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_ADD); }
#line 5079 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 393: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_SUB  */
#line 1299 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_SUB); }
#line 5085 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 394: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XCHG  */
#line 1300 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XCHG); }
#line 5091 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 395: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_INC  */
#line 1301 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_INC); }
#line 5097 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 396: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_DEC  */
#line 1302 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_DEC); }
#line 5103 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 397: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_CMPXCHG  */
#line 1303 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_CMPXCHG); }
#line 5109 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 398: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MIN  */
#line 1304 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MIN); }
#line 5115 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 399: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MAX  */
#line 1305 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MAX); }
#line 5121 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 400: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_AND  */
#line 1306 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_AND); }
#line 5127 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 401: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_OR  */
#line 1307 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_OR); }
#line 5133 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 402: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XOR  */
#line 1308 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XOR); }
#line 5139 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 409: /* cat6_ibo_opc_1src: T_OP_RESINFO  */
#line 1320 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RESINFO); }
#line 5145 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 410: /* cat6_ibo_opc_ldgb: T_OP_LDGB  */
#line 1322 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LDGB); }
#line 5151 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 411: /* cat6_ibo_opc_stgb: T_OP_STGB  */
#line 1323 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_STGB); }
#line 5157 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 414: /* $@39: %empty  */
#line 1327 "../src/freedreno/ir3/ir3_parser.y"
                                                                                  { dummy_dst(); }
#line 5163 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 416: /* cat6_id_opc: T_OP_GETSPID  */
#line 1330 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETSPID); }
#line 5169 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 417: /* cat6_id_opc: T_OP_GETWID  */
#line 1331 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETWID); }
#line 5175 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 418: /* cat6_id_opc: T_OP_GETFIBERID  */
#line 1332 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETFIBERID); }
#line 5181 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 421: /* cat6_bindless_base: '.' T_BASE  */
#line 1337 "../src/freedreno/ir3/ir3_parser.y"
                              { instr->flags |= IR3_INSTR_B; instr->cat6.base = (yyvsp[0].tok); }
#line 5187 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 424: /* cat6_bindless_mode: T_NONUNIFORM cat6_bindless_base  */
#line 1341 "../src/freedreno/ir3/ir3_parser.y"
                                                   { instr->flags |= IR3_INSTR_NONUNIF; }
#line 5193 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 426: /* cat6_reg_or_immed: integer  */
#line 1344 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5199 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 427: /* cat6_bindless_ibo_opc_1src: T_OP_RESINFO_B  */
#line 1346 "../src/freedreno/ir3/ir3_parser.y"
                                                 { new_instr(OPC_RESINFO); }
#line 5205 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 428: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_ADD  */
#line 1348 "../src/freedreno/ir3/ir3_parser.y"
                                                     { new_instr(OPC_ATOMIC_B_ADD); dummy_dst(); }
#line 5211 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 429: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_SUB  */
#line 1349 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_SUB); dummy_dst(); }
#line 5217 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 430: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XCHG  */
#line 1350 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XCHG); dummy_dst(); }
#line 5223 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 431: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_INC  */
#line 1351 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_INC); dummy_dst(); }
#line 5229 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 432: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_DEC  */
#line 1352 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_DEC); dummy_dst(); }
#line 5235 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 433: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_CMPXCHG  */
#line 1353 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_CMPXCHG); dummy_dst(); }
#line 5241 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 434: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MIN  */
#line 1354 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MIN); dummy_dst(); }
#line 5247 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 435: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MAX  */
#line 1355 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MAX); dummy_dst(); }
#line 5253 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 436: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_AND  */
#line 1356 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_AND); dummy_dst(); }
#line 5259 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 437: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_OR  */
#line 1357 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_OR); dummy_dst(); }
#line 5265 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 438: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XOR  */
#line 1358 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XOR); dummy_dst(); }
#line 5271 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 439: /* cat6_bindless_ibo_opc_3src: T_OP_STIB_B  */
#line 1360 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_STIB); dummy_dst(); }
#line 5277 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 440: /* cat6_bindless_ibo_opc_3src_dst: T_OP_LDIB_B  */
#line 1362 "../src/freedreno/ir3/ir3_parser.y"
                                                         { new_instr(OPC_LDIB); }
#line 5283 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 442: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1365 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); }
#line 5289 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 443: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_3src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed src_uoffset ',' cat6_reg_or_immed  */
#line 1366 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                                  { swap(instr->srcs[0], instr->srcs[3]); }
#line 5295 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 444: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_3src_dst cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed src_uoffset ',' cat6_reg_or_immed  */
#line 1367 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); swap(instr->srcs[1], instr->srcs[2]); }
#line 5301 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 445: /* cat6_bindless_ldc_opc: T_OP_LDC  */
#line 1369 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_LDC); }
#line 5307 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 446: /* cat6_bindless_ldc_middle: T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg  */
#line 1373 "../src/freedreno/ir3/ir3_parser.y"
                                                                               { instr->cat6.d = (yyvsp[-5].tok); }
#line 5313 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 447: /* cat6_bindless_ldc_middle: 'u' '.' T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg  */
#line 1374 "../src/freedreno/ir3/ir3_parser.y"
                                                                                       { instr->flags |= IR3_INSTR_U; instr->cat6.d = (yyvsp[-5].tok); }
#line 5319 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 448: /* cat6_bindless_ldc_middle: cat6_immed '.' 'k' '.' cat6_bindless_mode 'c' '[' T_A1 ']'  */
#line 1375 "../src/freedreno/ir3/ir3_parser.y"
                                                                                   { instr->opc = OPC_LDC_K; }
#line 5325 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 449: /* cat6_bindless_ldc: cat6_bindless_ldc_opc '.' cat6_bindless_ldc_middle ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1377 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                  {
                      instr->cat6.type = TYPE_U32;
                      /* TODO cleanup ir3 src order: */
                      swap(instr->srcs[0], instr->srcs[1]);
                   }
#line 5335 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 450: /* const_dst: integer  */
#line 1383 "../src/freedreno/ir3/ir3_parser.y"
                          { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5341 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 451: /* const_dst: T_A1  */
#line 1384 "../src/freedreno/ir3/ir3_parser.y"
                       { new_src(0, IR3_REG_IMMED)->iim_val = 0; instr->flags |= IR3_INSTR_A1EN; }
#line 5347 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 452: /* const_dst: T_A1 '+' integer  */
#line 1385 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); instr->flags |= IR3_INSTR_A1EN; }
#line 5353 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 453: /* $@40: %empty  */
#line 1388 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STC); }
#line 5359 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 455: /* $@41: %empty  */
#line 1389 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STSC); }
#line 5365 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 457: /* cat6_shfl_mode: T_MOD_XOR  */
#line 1391 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat6.shfl_mode = SHFL_XOR;   }
#line 5371 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 458: /* cat6_shfl_mode: T_MOD_UP  */
#line 1392 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat6.shfl_mode = SHFL_UP;    }
#line 5377 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 459: /* cat6_shfl_mode: T_MOD_DOWN  */
#line 1393 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat6.shfl_mode = SHFL_DOWN;  }
#line 5383 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 460: /* cat6_shfl_mode: T_MOD_RUP  */
#line 1394 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat6.shfl_mode = SHFL_RUP;   }
#line 5389 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 461: /* cat6_shfl_mode: T_MOD_RDOWN  */
#line 1395 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat6.shfl_mode = SHFL_RDOWN; }
#line 5395 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 462: /* cat6_shfl_mode: integer  */
#line 1399 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat6.shfl_mode = (yyvsp[0].num); }
#line 5401 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 463: /* $@42: %empty  */
#line 1402 "../src/freedreno/ir3/ir3_parser.y"
                   { new_instr(OPC_SHFL); }
#line 5407 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 465: /* cat6_todo: T_OP_G2L  */
#line 1405 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_G2L); }
#line 5413 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 466: /* cat6_todo: T_OP_L2G  */
#line 1406 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_L2G); }
#line 5419 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 467: /* cat6_todo: T_OP_RESFMT  */
#line 1407 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_RESFMT); }
#line 5425 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 481: /* cat7_scope: '.' 'w'  */
#line 1423 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.w = true; }
#line 5431 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 482: /* cat7_scope: '.' 'r'  */
#line 1424 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.r = true; }
#line 5437 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 483: /* cat7_scope: '.' 'l'  */
#line 1425 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.l = true; }
#line 5443 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 484: /* cat7_scope: '.' 'g'  */
#line 1426 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.g = true; }
#line 5449 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 487: /* $@43: %empty  */
#line 1431 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_BAR); }
#line 5455 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 489: /* $@44: %empty  */
#line 1432 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_FENCE); }
#line 5461 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 491: /* cat7_data_cache: T_OP_DCCLN  */
#line 1434 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCCLN); }
#line 5467 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 492: /* cat7_data_cache: T_OP_DCINV  */
#line 1435 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCINV); }
#line 5473 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 493: /* cat7_data_cache: T_OP_DCFLU  */
#line 1436 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCFLU); }
#line 5479 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 496: /* cat7_alias_scope: T_MOD_TEX  */
#line 1441 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_TEX; }
#line 5485 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 497: /* cat7_alias_scope: T_MOD_MEM  */
#line 1442 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_MEM; }
#line 5491 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 498: /* cat7_alias_scope: T_MOD_RT  */
#line 1443 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_RT; }
#line 5497 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 501: /* cat7_instr: T_OP_SLEEP  */
#line 1447 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_SLEEP); }
#line 5503 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 502: /* cat7_instr: T_OP_CCINV  */
#line 1448 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_CCINV); }
#line 5509 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 503: /* cat7_instr: T_OP_ICINV  */
#line 1449 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_ICINV); }
#line 5515 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 504: /* cat7_instr: T_OP_LOCK  */
#line 1450 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_LOCK); }
#line 5521 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 505: /* cat7_instr: T_OP_UNLOCK  */
#line 1451 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_UNLOCK); }
#line 5527 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 506: /* $@45: %empty  */
#line 1452 "../src/freedreno/ir3/ir3_parser.y"
                              {
                       /* TODO: handle T_INSTR_TYPE */
                       new_instr(OPC_ALIAS);
                   }
#line 5536 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 507: /* cat7_instr: T_OP_ALIAS $@45 '.' cat7_alias_scope '.' T_INSTR_TYPE '.' integer dst_reg ',' cat7_alias_src  */
#line 1455 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 5544 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 508: /* raw_instr: T_RAW  */
#line 1459 "../src/freedreno/ir3/ir3_parser.y"
                   {new_instr(OPC_META_RAW)->raw.value = (yyvsp[0].u64);}
#line 5550 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 511: /* meta_print_reg: ',' T_REGISTER  */
#line 1464 "../src/freedreno/ir3/ir3_parser.y"
                               {
	meta_print_data.regs_to_dump[meta_print_data.regs_count++] = (yyvsp[0].num);
}
#line 5558 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 512: /* meta_print_start: T_OP_PRINT T_REGISTER  */
#line 1468 "../src/freedreno/ir3/ir3_parser.y"
                                        {
	meta_print_data.reg_address_lo = (yyvsp[0].num);
	meta_print_data.reg_address_hi = (yyvsp[0].num) + 2;
	meta_print_data.reg_tmp = (yyvsp[0].num) + 4;
	meta_print_data.regs_count = 0;
}
#line 5569 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 513: /* meta_print: meta_print_start meta_print_regs  */
#line 1475 "../src/freedreno/ir3/ir3_parser.y"
                                             {
	/* low */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst(meta_print_data.reg_address_lo, 0);
	new_src(0, IR3_REG_IMMED)->uim_val = info->shader_print_buffer_iova & 0xffffffff;

	/* high */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst(meta_print_data.reg_address_hi, 0);
	new_src(0, IR3_REG_IMMED)->uim_val = info->shader_print_buffer_iova >> 32;

	/* offset */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst(meta_print_data.reg_tmp, 0);
	new_src(0, IR3_REG_IMMED)->uim_val = 4 * meta_print_data.regs_count;

	new_instr(OPC_NOP);
	instr->repeat = 5;

	/* Increment and get current offset into print buffer */
	new_instr(OPC_ATOMIC_G_ADD);
	instr->cat6.d = 1;
	instr->cat6.typed = 0;
	instr->cat6.type = TYPE_U32;
	instr->cat6.iim_val = 1;

	new_dst(meta_print_data.reg_address_lo, 0);
	new_src(meta_print_data.reg_address_lo, 0);
	new_src(meta_print_data.reg_tmp, 0);

	/* Store all regs */
	for (uint32_t i = 0; i < meta_print_data.regs_count; i++) {
		new_instr(OPC_STG);
		dummy_dst();
		instr->cat6.type = TYPE_U32;
		instr->flags = IR3_INSTR_SY;
		new_src(meta_print_data.reg_address_lo, 0);
		new_src(0, IR3_REG_IMMED)->iim_val = 0;
		new_src(meta_print_data.regs_to_dump[i], IR3_REG_R);
		new_src(0, IR3_REG_IMMED)->iim_val = 1;

		new_instr(OPC_ADD_U);
		instr->flags = IR3_INSTR_SS;
		new_dst(meta_print_data.reg_address_lo, 0);
		new_src(meta_print_data.reg_address_lo, 0);
		new_src(0, IR3_REG_IMMED)->uim_val = 4;

		new_instr(OPC_NOP);
		instr->repeat = 5;
	}
}
#line 5631 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 514: /* src_gpr: T_REGISTER  */
#line 1533 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), 0); }
#line 5637 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 515: /* src_a0: T_A0  */
#line 1534 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3), IR3_REG_HALF); }
#line 5643 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 516: /* src_a1: T_A1  */
#line 1535 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3) + 1, IR3_REG_HALF); }
#line 5649 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 517: /* src_p0: T_P0  */
#line 1536 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 5655 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 522: /* dst: T_REGISTER  */
#line 1543 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((yyvsp[0].num), 0); }
#line 5661 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 523: /* dst: T_A0  */
#line 1544 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3), IR3_REG_HALF); }
#line 5667 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 524: /* dst: T_A1  */
#line 1545 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3) + 1, IR3_REG_HALF); }
#line 5673 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 525: /* dst: T_P0  */
#line 1546 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((62 << 3) + (yyvsp[0].num), IR3_REG_PREDICATE); }
#line 5679 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 526: /* const: T_CONSTANT  */
#line 1548 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), IR3_REG_CONST); }
#line 5685 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 527: /* dst_reg_flag: T_EVEN  */
#line 1550 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_EVEN; }
#line 5691 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 528: /* dst_reg_flag: T_POS_INFINITY  */
#line 1551 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_POS_INF; }
#line 5697 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 529: /* dst_reg_flag: T_NEG_INFINITY  */
#line 1552 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_NEG_INF; }
#line 5703 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 530: /* dst_reg_flag: T_EI  */
#line 1553 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_EI; }
#line 5709 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 531: /* dst_reg_flag: T_WRMASK  */
#line 1554 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.wrmask = (yyvsp[0].num); }
#line 5715 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 534: /* dst_reg: dst  */
#line 1560 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5721 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 535: /* dst_reg: dst_reg_flags dst  */
#line 1561 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5727 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 536: /* src_reg_flag: T_ABSNEG  */
#line 1563 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS|IR3_REG_NEGATE; }
#line 5733 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 537: /* src_reg_flag: T_NEG  */
#line 1564 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_NEGATE; }
#line 5739 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 538: /* src_reg_flag: T_ABS  */
#line 1565 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS; }
#line 5745 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 539: /* src_reg_flag: T_R  */
#line 1566 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_R; }
#line 5751 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 540: /* src_reg_flag: T_LAST  */
#line 1567 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_LAST_USE; }
#line 5757 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 560: /* uoffset: %empty  */
#line 1596 "../src/freedreno/ir3/ir3_parser.y"
                   { (yyval.num) = 0; }
#line 5763 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 561: /* uoffset: '+' integer  */
#line 1597 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5769 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 563: /* offset: '-' integer  */
#line 1600 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5775 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 564: /* src_uoffset: uoffset  */
#line 1602 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); if ((yyvsp[0].num)) instr->flags |= IR3_INSTR_IMM_OFFSET; }
#line 5781 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 565: /* relative_gpr_src: 'r' '<' T_A0 offset '>'  */
#line 1604 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5787 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 566: /* relative_gpr_src: T_HR '<' T_A0 offset '>'  */
#line 1605 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5793 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 567: /* relative_gpr_dst: 'r' '<' T_A0 offset '>'  */
#line 1607 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_dst(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5799 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 568: /* relative_gpr_dst: T_HR '<' T_A0 offset '>'  */
#line 1608 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_dst(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5805 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 569: /* relative_const: 'c' '<' T_A0 offset '>'  */
#line 1610 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST)->array.offset = (yyvsp[-1].num); }
#line 5811 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 570: /* relative_const: T_HC '<' T_A0 offset '>'  */
#line 1611 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5817 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 573: /* immediate_cat1: integer  */
#line 1623 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = type_size(instr->cat1.src_type) < 32 ? (yyvsp[0].num) & 0xffff : (yyvsp[0].num); }
#line 5823 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 574: /* immediate_cat1: '(' integer ')'  */
#line 1624 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5829 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 575: /* immediate_cat1: '(' float ')'  */
#line 1625 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].flt); }
#line 5835 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 576: /* immediate_cat1: 'h' '(' integer ')'  */
#line 1626 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num) & 0xffff; }
#line 5841 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 577: /* immediate_cat1: 'h' '(' float ')'  */
#line 1627 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = _mesa_float_to_half((yyvsp[-1].flt)); }
#line 5847 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 578: /* immediate_cat1: '(' T_NAN ')'  */
#line 1628 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = NAN; }
#line 5853 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 579: /* immediate_cat1: '(' T_INF ')'  */
#line 1629 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = INFINITY; }
#line 5859 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 580: /* immediate_cat1: T_FLUT_0_0  */
#line 1630 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = 0.0; }
#line 5865 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 581: /* immediate_cat1: T_FLUT_0_5  */
#line 1631 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = 0.5; }
#line 5871 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 582: /* immediate_cat1: T_FLUT_1_0  */
#line 1632 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = 1.0; }
#line 5877 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 583: /* immediate_cat1: T_FLUT_2_0  */
#line 1633 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = 2.0; }
#line 5883 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 584: /* immediate_cat1: T_FLUT_4_0  */
#line 1634 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = 4.0; }
#line 5889 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 585: /* immediate: integer  */
#line 1636 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5895 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 586: /* immediate: '(' integer ')'  */
#line 1637 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5901 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 587: /* immediate: flut_immed  */
#line 1638 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); }
#line 5907 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 588: /* immediate: 'h' '(' integer ')'  */
#line 1639 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num); }
#line 5913 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 589: /* immediate: 'h' flut_immed  */
#line 1640 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = (yyvsp[0].num); }
#line 5919 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 602: /* integer: T_INT  */
#line 1656 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5925 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 603: /* integer: '-' T_INT  */
#line 1657 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5931 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 604: /* integer: T_HEX  */
#line 1658 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].unum); }
#line 5937 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 605: /* integer: '-' T_HEX  */
#line 1659 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].unum); }
#line 5943 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 606: /* float: T_FLOAT  */
#line 1661 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = (yyvsp[0].flt); }
#line 5949 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 607: /* float: '-' T_FLOAT  */
#line 1662 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = -(yyvsp[0].flt); }
#line 5955 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 608: /* type: T_TYPE_F16  */
#line 1664 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_F16;   }
#line 5961 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 609: /* type: T_TYPE_F32  */
#line 1665 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_F32;   }
#line 5967 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 610: /* type: T_TYPE_U16  */
#line 1666 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_U16;   }
#line 5973 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 611: /* type: T_TYPE_U32  */
#line 1667 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_U32;   }
#line 5979 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 612: /* type: T_TYPE_S16  */
#line 1668 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_S16;   }
#line 5985 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 613: /* type: T_TYPE_S32  */
#line 1669 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_S32;   }
#line 5991 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 614: /* type: T_TYPE_U8  */
#line 1670 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_U8;    }
#line 5997 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 615: /* type: T_TYPE_U8_32  */
#line 1671 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_U8_32; }
#line 6003 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 616: /* type: T_TYPE_U64  */
#line 1672 "../src/freedreno/ir3/ir3_parser.y"
                                { (yyval.type) = TYPE_ATOMIC_U64;  }
#line 6009 "src/freedreno/ir3/ir3_parser.c"
    break;


#line 6013 "src/freedreno/ir3/ir3_parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

